/*
 *********************************************************
 *   Copyright 2005, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************
                                                          
 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.
                                                          
 This software should be used as a reference only, and it not
 intended for production use!
                                                          
                                                          
 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/
 
/*******************************************************************
*
* FILENAME	: adm6996_ap.c
* ABSTRACT	: API for setting IOCTL to adm6996 device.
* AUTHOR	: Zhanghaisen,CyberTAN Technology(GZ),2006-01-10
*
********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <fcntl.h>

#include "adm6996_ap.h"

/**************************************************************************
*
* NAME			: write_adm_file
* DESCRIPTION	: set IOCTL to "/dev/adm6996".
* INPUT			: fd	--- the file descriptor of the dev file
* 				  reg	--- the register address
* 				  val	--- the vale writed to the register
* OUTPUT		: 0: OK; -1:Error
*
**************************************************************************/

int write_adm_file(int fd,short reg,unsigned short val)
{
	wr_reg   wreg;
	if(reg >REG_ADDR_MAX)
	{
		print_err("reg(0x%x) unknown!!!\n",reg);
		return -1;
	}
	zhs_debug("write reg(add 0x%x) with %x\n",reg,val);
	wreg.reg_addr = reg;
	wreg.reg_val =val;

	if(0 >ioctl(fd,ADM_CMD_WR,&wreg))
	{
		print_err("ioctl ADM_CMD_WR (Reg0x%x:%x) failed!!!\n",reg,val);
		return -1;
	}
	return 0;
}

/**************************************************************************
*
* NAME			: reset_adm
* DESCRIPTION	: set IOCTL to "/dev/adm6996" for reset switch.
* INPUT			: NONE.
* OUTPUT		: NONE. 
*
**************************************************************************/

int reset_adm(void)
{
	int fd ;

	fd = open(SWI_DEVICE_MODULE_NAME ,O_WRONLY);
	if(-1 == fd)
	{
		print_err("%s() open %s failed!!!\n",__FUNCTION__,SWI_DEVICE_MODULE_NAME);
		return -1;
	}
	if(0 >ioctl(fd,ADM_CMD_RST,0))
	{
		print_err("ioctl ADM_CMD_RST  failed!!!\n");
		close(fd);
		return -1;
	}
	close(fd);
	return 0;
}
