#ifndef __ADM6996_AP__
#define __ADM6996_AP__
/* 
 *MACRO for ADM6996L EEprom Register
 */
#define MAX_PORT                                        5
#define SIGNATURE                                       0x0
#define PORT0_CONFIG                                    0x1
#define PORT1_CONFIG                            	0x3
#define PORT2_CONFIG                          		0x5
#define PORT3_CONFIG                            	0x7
#define PORT4_CONFIG                           		0x8
#define MII_PORT_CONFIG                        		0x9
#define MII_REGISTER_PORT_MII         			0xb
#define VLAN_PRIORITY_MAP                      		0xe
#define TOS_PRIORITY_MAP                       		0xf
#define MISCELLANEOUS_CONFIG_0      			0x10
#define MAC_CLONE_CONFIG                       		0x11
#define MISCELLANEOUS_CONFIG_1         			0x12
#define VLAN0_OUTBOUND_PORT_MAP        			0x13
#define VLAN1_OUTBOUND_PORT_MAP        			0x14
#define VLAN2_OUTBOUND_PORT_MAP        			0x15
#define VLAN3_OUTBOUND_PORT_MAP        			0x16
#define VLAN4_OUTBOUND_PORT_MAP       			0x17
#define VLAN5_OUTBOUND_PORT_MAP         		0x18
#define VLAN6_OUTBOUND_PORT_MAP        			0x19
#define VLAN7_OUTBOUND_PORT_MAP       			0x1a
#define VLAN8_OUTBOUND_PORT_MAP        			0x1b
#define VLAN9_OUTBOUND_PORT_MAP        			0x1c
#define VLAN10_OUTBOUND_PORT_MAP       			0x1d
#define VLAN11_OUTBOUND_PORT_MAP       			0x1e
#define VLAN12_OUTBOUND_PORT_MAP       			0x1f
#define VLAN13_OUTBOUND_PORT_MAP       			0x20
#define VLAN14_OUTBOUND_PORT_MAP       			0x21
#define VLAN15_OUTBOUND_PORT_MAP        		0x22
#define P0_BUFFER_THRESHOLD                    		0x23
#define P1_BUFFER_THRESHOLD                    		0x24
#define P2_BUFFER_THRESHOLD                    		0x25
#define P3_4_BUFFER_THRESHOLD           		0x26
#define TOTAL_MII_BUFFER_THRESHOLD     			0x27
/*
 *Register Field
 */             
//MAC_CLONE_CONFIG
#define ENABLE_MAC_CLONE         	 0x10
#define MODE_8021Q                       0x20
                                                                         
/*
 *port1-4 as LAN
 */
#define PORT_BASE_CFG            0x800f

#define OUT_TAG_OFFSET           4
#define PVID_OFFSET              10
#define LAN1_PORT_CONFIG         0x840f  //PVID=1,Untag
#define LAN2_PORT_CONFIG         0x880f  //PVID=2,Untag
#define LAN3_PORT_CONFIG         0x8c0f  //PVID=3,Untag
#define LAN4_PORT_CONFIG         0x900f  //PVID=4,Untag
#define WAN_PORT_CONFIG          0x880f  //PVID=2,Untag
#define CPU_PORT_CONFIG          0x941F  // port 5 PVID = 5, tag
#define VLAN1_PORT_MAP           0x0104  // Port 1+Port5
#define VLAN2_PORT_MAP           0x0110  // Port 2+Port5
#define VLAN3_PORT_MAP           0x0140  // Port 3+Port5
#define VLAN4_PORT_MAP           0x0180  // Port 4+Port5
#define OTHER_VLAN_PORT_MAP      0x0000
                                                                                                                             
#define SWI_DEVICE_MODULE_NAME  "/dev/adm6996"  // Define the device module name for
#define ADM_CMD_WR                   1
#define ADM_CMD_RST                  2
#define REG_ADDR_MAX                 0xff
#define print_err                    printf
                                                                                                                             
//#define ZHS_DEBUG
#ifdef ZHS_DEBUG
#define zhs_debug printf
#define show_cfg_reg() do{ \
                                                                                                                             
#else
#define zhs_debug(fmt,arg...)
#endif
#define get_vid(p)     ((p+1) )
#define getPortCfgByVID(vid,isTag) PORT_BASE_CFG | ((vid)<<PVID_OFFSET)  | (isTag<<OUT_TAG_OFFSET)
#define getPortCfgAddr0_3(n)           PORT0_CONFIG +n*2
#define SetPortCfg(n,vid,isTag) \
{\
/*      value = LAN##n##_PORT_CONFIG;*/ \
        unsigned short value = getPortCfgByVID(vid,isTag);\
        short port_addr = getPortCfgAddr(n);\
        zhs_debug("set port%d(addr:0x%x) 0x%x\n",n,port_addr,value);\
        write_adm(port_addr,value);\
}
#define getVLANMap(p0,p1,p2,p3,p4,p5) (p0)|(p1<<2)|(p2<<4)|(p3<<6)|(p4<<7)|(p5<<8)
#define SetVLANPortMap(n,p0,p1,p2,p3,p4,p5) \
{\
        unsigned short value = getVLANMap(p0,p1,p2,p3,p4,p5);\
        zhs_debug("set VLANGroup%d(addr:0x%x) 0x%x\n",n,VLAN0_OUTBOUND_PORT_MAP+n,value);\
        write_adm(VLAN0_OUTBOUND_PORT_MAP+n,value);\
}
typedef struct write_reg{
        unsigned short reg_val;
        unsigned short reg_addr;
        }wr_reg;

#define write_adm(reg,val)  write_adm_file(fd,reg,val)
extern short getPortCfgAddr(int n);
extern int write_adm_file(int fd,short reg,unsigned short val);
extern int reset_adm(void);

#endif
