/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <net/route.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <sys/sysinfo.h>
#include <bcmnvram.h>
#include <netconf.h>
#include <shutils.h>
#include <rc.h>
#include <code_pattern.h>
#include <cy_conf.h>

#include "utils.h"
#include "pvc.h"
#include "ledapp.h"
#include "rc.h"

#define IFUP (IFF_UP | IFF_RUNNING | IFF_BROADCAST | IFF_MULTICAST)

extern pid_t ppp_pid[MAX_CHAN];
extern int which_conn;
extern struct vcc_config *vcc_config_ptr;
extern int check_cur_encap(int which, char *encap);


#define PRINTD(args...)
#define foreach(word, wordlist, next) \
	for (next = &wordlist[strspn(wordlist, " ")], \
	     strncpy(word, next, sizeof(word)), \
	     word[strcspn(word, " ")] = '\0', \
	     word[sizeof(word) - 1] = '\0', \
	     next = strchr(next, ' '); \
	     strlen(word); \
	     next = next ? &next[strspn(next, " ")] : "", \
	     strncpy(word, next, sizeof(word)), \
	     word[strcspn(word, " ")] = '\0', \
	     word[sizeof(word) - 1] = '\0', \
	     next = strchr(next, ' '))


char *get_str_tab(char *str, int num, int pos, char delimp, char delims) 
{
    	char *new_str;
    	int i, j;                   /* pos in str */
    	int cp = 0, cs = 0;         /* num of delim */
    	int debut = 0;

    	for (i = 0; (str[i] != '\0') && (cp < num); i++) {
        	if (str[i] == delimp) {
            	cp++;
        	}
    	}

    	if (str[i] == '\0') {
        	return NULL;
    	}

    	for (j = 0; (str[i + j] != 0) && (cs < pos); j++) {
        	if (str[i + j] == delims) {
            	cs++;
        	}
	}

    	if (str[i + j] == 0 && cs != pos) {
        	return NULL;
    	}

    	debut = i + j;

    	for (; (str[i + j] != 0) && (str[i + j] != delimp) && (str[i + j] != delims); j++);

    	new_str = (char *) malloc((i + j - debut + 1) * sizeof(char));
    	bzero(new_str, i + j - debut + 1);

    	strncpy(new_str, str + debut, i + j - debut);

    	return new_str;
}



void l2tp_start_wan_done(int argc, char **argv) 
{
	char wanipaddr[20], wannetmask[20], wangateway[20], wanbroadcast[20];
	int which = atoi(nvram_safe_get("wan_active_connection"));
	int timeout = 5;
	char *wan_ifname = argv[1];

	PRINTD("entering %s wan_ifname %s\n", __FUNCTION__, wan_ifname);
	
	which_conn = atoi(nvram_safe_get("wan_active_connection"));
	//junzhao 2004.7.28 for time record
	if(which < MAX_CHAN)
	{
		char conf_name[16];
		memset(conf_name, 0, sizeof(conf_name));
		sprintf(conf_name, "wanuptime%d", which);
		if(nvram_match(conf_name, "0") && ((!strstr(wan_ifname, "ppp") || check_ppp_link(which)))) 
		{	
			struct sysinfo info;
			char buf[32];

			if (sysinfo(&info) == -1)
				strcpy(buf, "0");
			else
				sprintf(buf, "%ld", info.uptime);
			
			nvram_set(conf_name, buf);
		}
	}

	ram_modify_status(WAN_IFNAME, wan_ifname);
	/* get the info from real interface, and save to nvram */
	memset(wanipaddr, 0, sizeof(wanipaddr));
	memset(wannetmask, 0, sizeof(wannetmask));
	memset(wangateway, 0, sizeof(wangateway));
	memset(wanbroadcast, 0, sizeof(wanbroadcast));

	while(wanstatus_info_get(wan_ifname, "ipaddr", &wanipaddr[0]) < 0 && timeout--);
	ram_modify_status(WAN_IPADDR, wanipaddr);
	
	timeout = 5;
	while(wanstatus_info_get(wan_ifname, "netmask", &wannetmask[0]) < 0 && timeout--);

	ram_modify_status(WAN_NETMASK, wannetmask);
	
	timeout = 5;
	while(wanstatus_info_get(wan_ifname, "gateway", &wangateway[0]) < 0 && timeout--);
	//junzhao 2004.8.5 //for dhcp mode....
	if(strcmp(wangateway, "0.0.0.0")) 
		ram_modify_status(WAN_GATEWAY, wangateway);
	
	timeout = 5;
	while(wanstatus_info_get(wan_ifname, "broadcast", &wanbroadcast[0]) < 0 && timeout--);

	ram_modify_status(WAN_BROADCAST, wanbroadcast);
    	system("route del default");
	route_add(argv[1], 0, NULL, argv[5], NULL);
	/* Start firewall */
	
	stop_firewall();
	start_firewall();
	
	stop_snmp();
	start_snmp();

#if defined(CONFIG_CWMP)
	stop_cwmp();
	start_cwmp();	/* CPE WAN Management protocol */
#endif

	if(which < MAX_CHAN)
	{
		/* Set additional wan static routes if need */
		set_routes();
	}
	
	dns_to_resolv(which_conn);
	stop_dhcpd();
	start_dhcpd();

	/* Restart DNS proxy */
	stop_dns();
	start_dns();

	/* add for IGMP Proxy 2004-10-10 */
#ifdef IGMP_PROXY_SUPPORT
	stop_igmp_proxy();
	//sleep(2);
	start_igmp_proxy();
#endif

	//junzhao 2004.7.29 restart ipsec
	if(!strstr(wan_ifname, "ppp") || check_ppp_link(which))
	{

		//junzhao 2004.7.23 
		/* Restart RIP */
		stop_zebra();
		start_zebra();
	#ifdef NOMAD_SUPPORT
	//zhs add for quickvpn,3-28-2005
                set_ipsec_def_ipt();
                att_ipsec0_t0_def_wan();
        //end by zhs
	#endif
		stop_ipsec();
		start_ipsec();

	#if defined(GRE_SUPPORT) || defined(CLOUD_SUPPORT)
		stop_gre();
		enable_gre();
	#endif

		//junzhao 2004.7.29 restart qos
	#if defined(QOS_SUPPORT) || defined(QOS_ADVANCED_SUPPORT)
		stop_qos();
		start_qos();
	#endif
		
		//junzhao 2004.9.14
		stop_upnp(2);
	}
	
	if((which == which_conn)) {	
		if(strstr(wan_ifname, "ppp")) {
			FILE *fp;
			char linkfile[18];
			memset(linkfile, 0, sizeof(linkfile));
			sprintf(linkfile, "/tmp/ppp/link%d", which);
			fp = fopen(linkfile, "r");
			if(fp != NULL) {
				start_wan_service();
				fclose(fp);

			}
		} else
			start_wan_service();
	}
	dprintf("done\n");
}

extern char * range(char *start, char *end);

int ipup_l2tp(int argc,char **argv) 
{
	FILE *fp;
//	char *wan_ifname = safe_getenv("IFNAME");
	char *wan_ifname = argv[1];
	char *value;
	char *filename;
	char encap[15];
	int which_tmp = atoi(nvram_safe_get("wan_active_connection"));
	char *config_ptr;
	int shift;
	char *lns_peer;
	char *ppp_username;
	char *ppp_passwd;
	int i;
	char *route_static;
	char *l_demand, *l_idletime;	
	PRINTD("entering %s\n", __FUNCTION__);
	
	if(check_action() != ACT_IDLE)
                return -1;

	/* ipup will receive bellow six arguments */
	/* interface-name  tty-device  speed  local-IP-address   remote-IP-address ipparam */
	/* Touch connection file  for current connection */
	/* ipparam == "0" : first ppp */
	/* ipparam == "1" : over l2tp */

	which_conn = atoi(&wan_ifname[3]);  //set the global flag!!!!important

	vcc_global_init();


	if(which_conn < which_tmp) {
		char index[3];
		eval("/usr/bin/route", "del", "default");
		memset(index, 0, sizeof(index));
		sprintf(index, "%d", which_conn);
		nvram_set("wan_active_connection", index);
		nvram_set("wan_enable_last", index);
		which_tmp = which_conn;
	}
	
#if defined(MPPPOE_SUPPORT) || defined(IPPPOE_SUPPORT)
	if(which_conn > MAX_CHAN-1)
		which_conn -= MAX_CHAN;
	memset(encap, 0, sizeof(encap));
	check_cur_encap(which_conn, encap);
#endif


	filename = malloc(strlen("/tmp/ppp/link.down") + 3);
	if(filename == NULL)
		return -1;
	memset(filename, 0, strlen("/tmp/ppp/link.down"+3));
	sprintf(filename, "/tmp/ppp/link%d.down", which_conn);
	unlink(filename);

	//junzhao 2004.10.28
	memset(filename, 0, strlen("/tmp/ppp/link.idle"+3));
	sprintf(filename, "/tmp/ppp/link%d.idle", which_conn);
	unlink(filename);
	
	free(filename);

	filename = malloc(strlen("/tmp/ppp/link") + 3);
	if(filename == NULL)
		return -1;
	memset(filename, 0, strlen("/tmp/ppp/link"+3));
	sprintf(filename, "%s%d", "/tmp/ppp/link", which_conn);
	if (!(fp = fopen(filename, "a"))) {
		perror(filename);
		return errno;
	}

	fprintf(fp, "%s\n", argv[1]);

	fclose(fp);
	free(filename);
	filename = NULL;


	if ((value = getenv("IPLOCAL"))) {
		ifconfig(wan_ifname, IFUP, value, "255.255.255.255");
	}
	
	//junzhao 2004.4.19 get ac_name
	{
	char acname[1024];
	if(file_to_buf("/tmp/ppp/acname", acname, sizeof(acname)))
		ram_modify_status(WAN_PPPOE_ACNAME, acname);
	}
	
	{
	char srvname[1024];
	if(file_to_buf("/tmp/ppp/srvname", srvname, sizeof(srvname)))
		ram_modify_status(WAN_PPPOE_SRVNAME, srvname);
	}

	{
	char filename[30];
	memset(filename, 0, sizeof(filename));
	sprintf(filename, "/tmp/ppp/authfail%d", atoi(&wan_ifname[3])); 
	unlink(filename);
	}
	
	/* launch l2tp */
	if (!strcmp(encapmode, "l2tp_pppoe")) {
	/* login:passwd:mode:timeout:delay:domain:LNS:username:passwd */
		config_ptr = nvram_safe_get("l2tp_pppoe_config");
		shift=1; /* due to domain in pppoe config */
	} else {
	/* login:passwd:mode:timeout:delay:LNS:username:passwd */
		config_ptr = nvram_safe_get("l2tp_pppoa_config");	
		shift=0;
	}
	l_demand = get_str_tab (config_ptr, which_conn, 2, ' ', ':');	
	l_idletime = get_str_tab (config_ptr, which_conn, 3, ' ', ':');
	lns_peer = get_str_tab(config_ptr, which_conn, shift+5, ' ', ':');
	ppp_username = get_str_tab(config_ptr, which_conn, shift+6, ' ', ':');
	ppp_passwd = get_str_tab(config_ptr, which_conn, shift+7, ' ', ':');

	{ /* save old param */
		char *dns1 = getenv("DNS1");
		char *dns2 = getenv("DNS2");
		FILE *fp = fopen("/tmp/ppp/old_ip", "w");
	
		fprintf(fp, "%s", argv[4]);
		fclose(fp);
		fp = fopen("/tmp/ppp/old_gw", "w");
		fprintf(fp, "%s", argv[5]);
		fclose(fp);
		fp = fopen("/tmp/ppp/old_dns1", "w");
		fprintf(fp, "%s", (dns1==NULL)?"":dns1);
		fclose(fp);
		fp = fopen("/tmp/ppp/old_dns2", "w");
		fprintf(fp, "%s", (dns2==NULL)?"":dns2);
		fclose(fp);
	}
	
	route_add(argv[1], 0, lns_peer, argv[5], "255.255.255.255");

	/* add static route through DSL */
	route_static = nvram_safe_get("l2tp_static_route");
	for(i=0;i<20;i++) {
		char *network,*netmask;

		network = get_str_tab(route_static, i, 0, ' ', ':');
		if (network == NULL) {
			continue;
		}
		if (network[0] == 0) {
			free(network);
			continue;	
		}
		netmask = get_str_tab(route_static, i, 1, ' ', ':');
		if (netmask == NULL) {
			free(network);
			continue;
		}
		if (netmask[0] == 0) {
			free(network);
			free(netmask);
			continue;	
		}

		route_add(argv[1], 0, network, argv[5], netmask);
		free(netmask);
		free(network);
	}
	
	/* basic firewall rules */
	{
		char buf[512];
		char tmp[32];
		char *next, *start_ip, *end_ip, *from, *to, *wordlist;
		char var[256];
		int ip_r;
		
		/* Lai add for initiation at 2006.01.10 */
		start_ip = end_ip = from = to = NULL;
		
		strncpy(tmp, nvram_safe_get("http_wanport"), 32);
		snprintf(buf, 512, "iptables -t nat -A PREROUTING -p tcp -m tcp -d %s --dport %s "
					  "-j DNAT --to-destination %s:%d", 
					  argv[4],
					  tmp,
					  nvram_safe_get("lan_ipaddr"), 
					  443);
		system(buf);
		strncpy(tmp, nvram_safe_get("telnet_wanport"), 32);
		snprintf(buf, 512, "iptables -t nat -A PREROUTING -p tcp -m tcp -d %s --dport %s "
					  "-j DNAT --to-destination %s:%d", 
					  argv[4],
					  tmp,
					  nvram_safe_get("lan_ipaddr"), 
					  23);
		system(buf);
		

		ip_r = atoi(nvram_safe_get("range_all"));
		if(ip_r == 0) {
			snprintf(buf, 512, "iptables -A INPUT -p tcp -m tcp -d %s --dport %d -j ACCEPT", nvram_safe_get("lan_ipaddr"), 443);
			system(buf);
			snprintf(buf, 512, "iptables -A INPUT -p tcp -m tcp -d %s --dport %d -j ACCEPT", nvram_safe_get("lan_ipaddr"), 23);
			system(buf);
		} else {			
			strcpy(start_ip,"range_start_ip");
			strcpy(end_ip,"range_end_ip");
			strcpy(from,nvram_safe_get(start_ip));
			strcpy(to,nvram_safe_get(end_ip));
			wordlist = range(from, to);
			foreach(var, wordlist, next)  {
				snprintf(buf, 512, "iptables -I INPUT  -s %s -d %s -p tcp --dport %d -j ACCEPT", var, nvram_safe_get("lan_ipaddr"),443);
				system(buf);
				snprintf(buf, 512, "iptables -I INPUT  -s %s -d %s -p tcp --dport %d -j ACCEPT", var, nvram_safe_get("lan_ipaddr"), 23);
				system(buf);
			}
		}
	}
	
	/* default route */
	route_add(argv[1], 0, NULL, argv[5], NULL);	
	
	mkdir("/tmp/l2tp", 0755);
	mkdir("/tmp/ppp-2.4.3", 0755);
	symlink("/sbin/rc", "/tmp/ppp-2.4.3/ip-up-l2tp");
	symlink("/sbin/rc", "/tmp/ppp-2.4.3/ip-down-l2tp");
	mkdir("/tmp/ppp-2.4.3/peers", 0755);
	
	fp = fopen("/tmp/ppp-2.4.3/peers/linksys", "w");
	fprintf(fp, "name linksys\n"
				"user %s\n"
				"password %s\n"
				"noipdefault\n"
				"ipcp-accept-local\n"
				"linkname linksys\n"
				"ipcp-accept-remote\n"
				"lcp-echo-interval 30\n"
				"lcp-echo-failure 6\n"
				"debug\n"
				"usepeerdns\n"
				"unit %d\n"
				"logfile /tmp/pppd.log\n", ppp_username, ppp_passwd, which_conn + PVC_CONNECTIONS);
	fclose(fp);
	if(!strcmp(l_demand, "1"))
	{
		fp = fopen ("/tmp/ppp-2.4.3/peers/linksys", "a");
       		fprintf (fp, "idle %d\n", (atoi (l_idletime)) * 60);
		fclose (fp);
	}

	
	fp = fopen("/tmp/ppp-2.4.3/pap-secrets", "w");
	fprintf(fp, "%s * %s linksys\n", ppp_username, ppp_passwd);
	fclose(fp);
	
	fp = fopen("/tmp/l2tp.conf", "w");
	fprintf(fp, "global\n"
				"load-handler \"sync-pppd.so\"\n"
				"load-handler \"cmd.so\"\n"
				"section sync-pppd\n"
				"lac-pppd-opts \"call linksys\"\n"
			//	"pppd-path \"/usr/sbin/pppd-2.4.3\"\n"
				"section peer\n"
				"peer %s\n"
				"port 1701\n"
				"lac-handler sync-pppd\n"
				"hide-avps no\n"
				"persist 1\n"
				"retain-tunnel 1\n"
				"section cmd\n", lns_peer);
	
	fclose(fp);

	system("/usr/sbin/l2tpd");
	
	{
		char buf[128];
		snprintf(buf, 128, "/usr/sbin/l2tp-control \"start-session %s\"", lns_peer);
		system(buf);
	}

  
	return 0;
}

int ipdown_l2tp(int argc,char **argv) 
{
	char *filename, *filename_new;
	char *wan_ifname = argv[1];
	char encap[15], gw[20], buf[50];
	int select_tmp = atoi(nvram_safe_get("active_connection_selection"));
	int which;
	FILE *fp;

	which_conn = atoi(nvram_safe_get("wan_active_connection"));  //set the global flag!!!!important
	which = which_conn;

	vcc_global_init();

	if(select_tmp != 32)
	{
		int data = 0;
		data |= which;
		data |= (1<<PPP_MASK);
		if(data == select_tmp)
			nvram_set("active_connection_selection", "32");
	}
	
	//junzhao 2004.7.28 for wan uptime record
	if(which_conn < MAX_CHAN)
	{
		char buf[16];
		memset(buf, 0, sizeof(buf));
		sprintf(buf, "wanuptime%d", which_conn);
		nvram_set(buf, "0");
	}
	
#if defined(MPPPOE_SUPPORT) || defined(IPPPOE_SUPPORT)
	if(which_conn > MAX_CHAN-1)
		which_conn -= MAX_CHAN;
	memset(encap, 0, sizeof(encap));
	check_cur_encap(which_conn, encap);
#endif
	if(check_action() != ACT_IDLE)
                return -1;
	filename = malloc(strlen("/tmp/ppp/link") + 3);
	if(filename == NULL)
		return -1;
	memset(filename, 0, strlen("/tmp/ppp/link"+3));
	sprintf(filename, "/tmp/ppp/link%d", which_conn);
	filename_new = malloc(strlen("/tmp/ppp/link.down") + 3);
	if(filename_new == NULL)
		return -1;
	memset(filename_new, 0, strlen("/tmp/ppp/link.down"+3));
	sprintf(filename_new, "/tmp/ppp/link%d.down", which_conn);

	rename(filename, filename_new);
	
	free(filename);
	filename = NULL;
	free(filename_new);
	filename_new = NULL;
	/* Lai: set the old default gw */
	if ((fp = fopen ("/tmp/ppp/old_gw", "r")) != NULL)
	{
		fscanf (fp, "%s", gw);
		fclose (fp);
	}
	sprintf (buf, "route add default gw %s", gw);	
	system (buf);			
	unlink("/tmp/ppp/resolv.conf");
	unlink("/tmp/ppp/acname");
	unlink("/tmp/ppp/srvname");
	
	unlink("/tmp/ppp/old_ip");
	unlink("/tmp/ppp/old_gw");
	unlink("/tmp/ppp/old_dns1");
	unlink("/tmp/ppp/old_dns2");
		
	ram_modify_status(WAN_IPADDR, "0.0.0.0");
	ram_modify_status(WAN_NETMASK, "0.0.0.0");
	ram_modify_status(WAN_GATEWAY, "0.0.0.0");
	ram_modify_status(WAN_GET_DNS, "0.0.0.0:0.0.0.0");
		
	ram_modify_status(WAN_PPPOE_ACNAME, "None" );
	ram_modify_status(WAN_PPPOE_SRVNAME, "None" );
	    	
	//junzhao 2004.9.14
    	stop_upnp(1);
		      
	/*add by peny*/
	#ifdef CWMP_SUPPORT
	    	stop_inform_dhcpc(which_conn);
	#endif
		/*end by peny*/

	if(which_conn == atoi(nvram_safe_get("wan_enable_last")))
	{
		stop_ddns();    // Aviod to trigger DOD
    		stop_ntp();
		stop_email_alert();
			//stop_upnp(1);
		#ifdef PARENTAL_CONTROL_SUPPORT
 			stop_parental_control();	
		#endif
			
			//junzhao 2004.7.27
		if(!check_ppp_idle(which_conn))
		{
			if(add_next_gw())
			{
				start_ddns();
				start_ntp();
				start_email_alert();
				stop_upnp(2);
			#ifdef PARENTAL_CONTROL_SUPPORT
				start_parental_control();
			#endif
			}
		}
	}	

	stop_firewall();
	start_firewall();
	
	dns_to_resolv(which_conn);
	/* Restart DHCP server */
	stop_dhcpd();
	start_dhcpd();

	/* Restart DNS proxy */
	stop_dns();
	start_dns();
	
	//junzhao 2004.7.23 
	/* Restart RIP */
	stop_zebra();
	start_zebra();

	/* zhangbin 2005.5.11 */


	//junzhao 2004.7.29 restart qos
	//stop_qos();
	//start_qos();
#if defined(QOS_SUPPORT) || defined(QOS_ADVANCED_SUPPORT)
	down_qos(wan_ifname, atoi(&wan_ifname[3]));
#endif

	//junzhao 2004.7.29 restart ipsec
	//stop_ipsec();
	//start_ipsec();
	//down_ipsec(wan_ifname, which_conn); //zhangbin 2004.08.12
	
	{
	char filename[30];
	memset(filename, 0, sizeof(filename));
	sprintf(filename, "/tmp/ppp/authfail%d", atoi(&wan_ifname[3])); 
	unlink(filename);
	}
	
	eval("killall", "l2tpd");
	
	return 0;	
}

int ipup_finish(int argc,char **argv) {
	char buf[64];
	char *dns1, *dns2;
	FILE *fp;

	which_conn = atoi(nvram_safe_get("wan_active_connection"));  //set the global flag!!!!important
	
	dns1 = getenv("DNS1");
	dns2 = getenv("DNS2");
	if (dns1 == NULL) {
		if (dns2 == NULL) {
			snprintf(buf, 64, "0.0.0.0:0.0.0.0");	
		} else {
			snprintf(buf, 64, "%s:0.0.0.0", dns2);	
		}
	} else {
		if (dns2 == NULL) {
			snprintf(buf, 64, "%s:0.0.0.0", dns1);	
		} else {
			snprintf(buf, 64, "%s:%s", dns1, dns2);	
		}
	}
	ram_modify_status(WAN_GET_DNS, buf);
	
	snprintf(buf, 64, "/tmp/ppp-2.4.3/authfail");
	unlink(buf);
	snprintf(buf, 64, "/tmp/ppp-2.4.3/GetIPFail");
	unlink(buf);
	snprintf(buf, 64, "/tmp/ppp-2.4.3/link");
	if ((fp = fopen(buf, "w")) != NULL) {
		fclose(fp);
	}
	system("iptables -F");
		
	l2tp_start_wan_done(argc, argv);
	return 0;	
}

int ipdown_finish(int argc,char **argv) {
	char buf[64];
	
	snprintf(buf, 64, "/tmp/ppp-2.4.3/authfail");
	unlink(buf);
	snprintf(buf, 64, "/tmp/ppp-2.4.3/GetIPFail");
	unlink(buf);
	snprintf(buf, 64, "/tmp/ppp-2.4.3/link");
	unlink(buf);
	
	//ipdown_l2tp(argc, argv);
	return 0;	
}
