/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <time.h>
#include <sys/time.h>
#include <syslog.h>
#include <wait.h>
#include <fcntl.h>
#include <bcmnvram.h>
#include <shutils.h>
#include <rc.h>

#include <ntp.h>
#include <cy_conf.h>
#include <utils.h>

#define NTP_M_TIMER "3600" 
#define NTP_N_TIMER "60" 
#define SMTP_DEV	"/dev/smtp_server_dev"
#define JAN_1970	0x83aa7e90 
int time_sleep;

/*----add by zhs for debug info at console ,2006-01-11----*/
#if 0
#define debug_printf printf
#else
#define                 debug_printf(fmt,arg...)
#endif
/*----end by zhs for debug info at console ,2006-01-11----*/
                                                                                

typedef struct daylight {
	int year;
	int month;
	int day;
} DAYLIGHT;

void get_ntp_params(char **s,char *tz,int *en,DAYLIGHT *start,DAYLIGHT *end);
void get_day_from_str(DAYLIGHT *lightday,char *str);
/* da_f modify 2005.11.3 */
static int is_daylight(struct tm tm,DAYLIGHT *start,DAYLIGHT *end, int index);
int get_tz_index(char *tz);

/* for NTP */
/* Lai modify to fix sleep_time cannot be update bug at 2005.02.21 */
int do_ntp(void)
{
	DAYLIGHT start,end;
	unsigned long g_timestamp = 0;
	char	*ntp_servs[5];
	char	buf[1024],tz_buf[20];
	int	i,ret,mt,cnt;
	int	offset;
	struct	timeval tv;
	struct	timezone tz;
	struct	tm tm;
	int 	daylight_time;

	char *ntpclient_argv[] = {"ntpclient","-h",buf,"-l","-s",NULL};

	int fd,tzindex=0;  
	char timezone[10],timestamp[10];
	char *pos;

	//get ntp parameters value from nvram
	bzero(tz_buf, sizeof(tz_buf)); /* da_f add 2005.11.3 */
	get_ntp_params(ntp_servs,tz_buf,&daylight_time,&start,&end);
	offset = atoi(tz_buf)*3600;
	pos = strchr(tz_buf,'.');
	if( pos && *(pos+1)!='0' ){
		i = atoi(pos+1);
		if( i<10 ) i *= 10;
		while(i>100) i /= 10;
		/* da_f modify 2005.11.7 */
		if(offset >= 0)
			offset += i*3600/100;
		else
			offset -= i*3600/100;
	}
	cnt = time(NULL)%5;
	if(cnt < 0)	cnt += 5;
	if (nvram_match("ntp_mode", "manual") && nvram_invmatch("ntp_server", ""))
		strcpy(buf,nvram_safe_get("ntp_server"));
	else{
		strcpy(buf,ntp_servs[cnt]);
		for(i=0;i<5;i++){
			if( i== cnt) continue;
			sprintf(buf,"%s %s",buf,ntp_servs[i]);
		}
		debug_printf("NTP-Server List: %s\n",buf);  
	}		   
//get UTC time from NtpServers
	ret = _eval(ntpclient_argv, NULL, 20, NULL);

//update localtime
   	gettimeofday(&tv,&tz);
	g_timestamp = tv.tv_sec + JAN_1970;
	memcpy(&tm, localtime(&tv.tv_sec), sizeof(struct tm));
	mt = tm.tm_year+1900<2000?0:1;

	if( mt && !ret ) {
		tv.tv_sec += offset;
		memcpy(&tm, localtime(&tv.tv_sec), sizeof(struct tm));
	
		tzindex = get_tz_index(tz_buf);
		if( tzindex==-1 ){
			debug_printf("TimeZone not found in TzEntry,TimeZone[%s]\n",tz_buf);   
			return 0;
		}

		/* da_f modify 2005.11.3. 
		   Go to the is_daylight() function you'll know more about it. */
		if( daylight_time && is_daylight(tm,&start,&end,tzindex) ) 
		{
			tv.tv_sec += 3600;
			memcpy(&tm, localtime(&tv.tv_sec), sizeof(struct tm));
		}
		settimeofday(&tv,&tz);
//write TZInfo into SMTP-DEV
		fd = open(SMTP_DEV, O_RDWR);
		debug_printf("*****TzIndex=%d******\n", tzindex);
		if(fd < 0){
			debug_printf("Can not open the smtp device\n");		
		}
		else {
			memset(timezone, 0, sizeof(timezone));		
			memset(timestamp, 0,  sizeof(timestamp));
			sprintf(timestamp, "6%08x", (int)g_timestamp);
			timestamp[strlen(timestamp)] = 0;
			write(fd, timestamp, sizeof(timestamp));
			debug_printf("timestamp:%s\n", timestamp);
			sprintf(timezone, "7%08x", tzindex);
			timezone[strlen(timezone)] = 0;
			write(fd, timezone, sizeof(timezone));
			close(fd);
		}	
#ifndef NTPD_TEST
// firewall.c : synchronize the filter rules by TOD scheduling
		dprintf("NTP:filtersync\n");
		filtersync_main();
#endif
#ifdef FIREWALL_LEVEL_SUPPORT
		dprintf("ntp: filterinbsync\n");
		filterinbsync_main();
#endif
		//time_sleep = atoi(nvram_get("timer_interval"));
		return atoi(nvram_get("timer_interval"));
	}
	else {
		//time_sleep = atoi(NTP_N_TIMER);
		return atoi(NTP_N_TIMER);
	//	nvram_set("timer_interval",NTP_N_TIMER);
	}
	//return 0;
}

#ifdef NTPD_TEST
int main(int argc, char **argv)
#else
int ntp_main(int argc, char **argv)
#endif
{
	int status,interval;
	int fd[2];
	char p_buf[20];
	pid_t pid;
	
	/* Lai add pipe to fix time_sleep value cannot be update bug
	   at 2005.02.21 
	time_sleep = atoi(NTP_N_TIMER); */
	interval = atoi(NTP_N_TIMER);

	while(1) 
	{
		pipe(fd);
		pid = fork();
	
		if(pid<0) {
			perror("fork failed");
			exit(1);
		}
		if( !pid ) {
			close(fd[0]);
			if(check_action() == ACT_IDLE)
			{	// Don't execute during upgrading
				/*----zhs md for error info,2006-01-09----*/
				char cmd_buf[100] = {0};
				char t_interval[20];
				
				sprintf(cmd_buf,"killall ntpclient 2> /dev/null");
				system(cmd_buf);
				//eval("killall","-9","ntpclient");
				/*---end by zhs md for error info,2006-01-09 -*/
				//do_ntp();
				sprintf(t_interval, "%d", do_ntp());
				write(fd[1], t_interval, strlen(t_interval));
			}
			else
			{
				write(fd[1], "!ACT_IDLE", strlen("!ACT_IDLE"));
				fprintf(stderr, "ntp: nothing to do...\n");
			}
			exit(0);
		}
		else 
		{
			close(fd[1]);
			memset(p_buf, 0, sizeof(p_buf));
			read(fd[0], p_buf, sizeof(p_buf));
			if (!strstr(p_buf, "!ACT_IDLE"))
				interval = atoi(p_buf);
			waitpid(pid, &status, 0);
		}
		//interval=time_sleep;
		sleep(interval);	
	}
}

int stop_ntp(void)
{
	int ret = eval("killall","-9", "ntpd");
	dprintf("done\n");
	return ret;
}

int start_ntp(void)
{
	int ret;
	pid_t pid;
	char *ntp_argv[] = { "ntpd", NULL };

   ret = _eval(ntp_argv, NULL, 0, &pid);
   dprintf("done\n");
   return ret;
}

//the following functions added by juven.cui,2004-09-01

/* get ntp parameters from nvram */
void get_ntp_params(char **servs,char *tzbuf,int *daylight_used,DAYLIGHT *start,DAYLIGHT *end)
{
	*servs++ = strdup(nvram_get("NTPServer1"));
	*servs++ = strdup(nvram_get("NTPServer2"));
	*servs++ = strdup(nvram_get("NTPServer3"));
	*servs++ = strdup(nvram_get("NTPServer4"));
	*servs   = strdup(nvram_get("NTPServer5"));
	strcpy(tzbuf,nvram_get("time_zone"));
	*daylight_used = atoi(nvram_get("daylight_time"));
#ifdef CPED_TR064_SUPPORT
	get_day_from_str(start,nvram_get("DaylightSavingStart"));
	get_day_from_str(end,nvram_get("DaylightSavingEnd"));
#endif
}

/* str format likes "2001-07-01T00:00:00" */
void get_day_from_str(DAYLIGHT *lightday,char *str)
{
	char *p0=str,*p1=str;
	char tmp[8];
	if(!strcmp(str,""))
		return;
	p1 = strchr(p0,'-');
	strncpy(tmp,p0,p1-p0);
	tmp[p1-p0]=0;
	lightday->year=atoi(tmp);
	p0=p1+1;
	p1 = strchr(p0,'-');
	strncpy(tmp,p0,p1-p0);
	tmp[p1-p0]=0;
	lightday->month=atoi(tmp);
	p0=p1+1;
	p1 = strchr(p0,'T');
	strncpy(tmp,p0,p1-p0);
	tmp[p1-p0]=0;
	lightday->day=atoi(tmp);
}

/* da_f modify 2005.11.3 */
/* check time now betwen start & end or not */
int is_daylight(struct tm now,DAYLIGHT *start,DAYLIGHT *end,int index)
{
	int curmon=now.tm_mon+1;
	int curday=now.tm_mday;
	/* 0: endMonth > startMonth	1:startMonth > endMonth*/
	unsigned char diffMonth = dstEntry[(int)tzEntry[index].dstFlag].diffMonth;	

#ifdef CPED_TR064_SUPPORT

	/********************* Modified by tcy *****************/
	/* Fix the bug of "daylightsaving not correct in Apr".
	 * 2006-04-25
	 */
	int	start_mon = 0;
	int	end_mon = 0;
	int	start_day = 0;
	int	end_day = 0;	

	if(-1 == index)
	{
		return 0;
	}

	/* if "DaylightSavingStart" or "DaylightSavingEnd" is NULL in the nvram, then don't get value from nvram */
	if( strcmp(nvram_safe_get("DaylightSavingStart"), "") || strcmp(nvram_safe_get("DaylightSavingEnd"), ""))
	{
		start_mon = start->month;
		end_mon = end->month;
		start_day = start->day;
		end_day = end->day;
	}
	else
	{	
		start_mon = dstEntry[(int)tzEntry[index].dstFlag].startMonth;
		end_mon = dstEntry[(int)tzEntry[index].dstFlag].endMonth;
		start_day = dstEntry[(int)tzEntry[index].dstFlag].startDay[curmon];
		end_day = dstEntry[(int)tzEntry[index].dstFlag].endDay[curday];
	}

	/* in southern hemisphere, the daylightsaving is from Oct to next Apr */
	if( start_mon > end_mon || (start_mon == end_mon && start_day > end_day))
	{
		curmon += 12;
		end_mon += 12;
	}

	/* if daylightsaving, return 1; else, retun 0*/
	if(tzEntry[index].dstFlag
		&& ((curmon > start_mon && curmon < end_mon)
		|| (curmon == start_mon && curday >= start_day)
		|| (curmon == end_mon && curday <= end_day)))
	{
		return 1;
	}
	/********** end by tcy for daylightsaving bug, 2006-4-25 ***********/	

	return 0;
#else
	unsigned char startMonth = dstEntry[(int)tzEntry[index].dstFlag].startMonth;
	unsigned char endMonth = dstEntry[(int)tzEntry[index].dstFlag].endMonth;

	if(-1 == index)
		return 0;

	if (tzEntry[index].dstFlag &&
	(((diffMonth == 0) && 
		((curmon == startMonth && 
		  curday >= dstEntry[(int)tzEntry[index].dstFlag].startDay[curmon]) || 
		(curmon == endMonth && 
		 curday <= dstEntry[(int)tzEntry[index].dstFlag].endDay[curmon]) || 
		(curmon > startMonth && curmon < endMonth))) ||
	((diffMonth == 1) && 
		((curmon == startMonth && 
		  curday >= dstEntry[(int)tzEntry[index].dstFlag].startDay[curmon]) || 
		(curmon == endMonth && 
		 curday <= dstEntry[(int)tzEntry[index].dstFlag].endDay[curmon]) || 
		(curmon > startMonth || curmon < endMonth))))
	)
		return 1;

	return 0;
#endif
}

int get_tz_index(char *tzbuf)
{
	int i,near_index=-1,tz;
	char tmp[8],*p0,*p1;
	char trim_buf[20]; /* da_f add 2005.11.3 */

	/* da_f add 2005.11.3 */
	bzero(trim_buf, sizeof(trim_buf));
	/* eg. tzbuf: "+00 2 2" ----> trim_buf: "+00 2" */
	memcpy(trim_buf, tzbuf, strlen(tzbuf) - 2); 

	strtok(tzbuf," ");
	tz=atoi(tzbuf);
	p0 = strchr(tzbuf,'.');
	if( p0 && strcmp(p0,".5")>=0 )
		tz += *tzbuf=='-'?-1:1;
	for(i=0;i<tzEntrySize;i++){
		p0 = (char *)tzEntry[i].name;
		p1 = strchr(p0,' ');
		if(!p1) p1=p0+strlen(p0);
		strncpy(tmp,p0,p1-p0);
		tmp[p1-p0] = 0;
		/* da_f modify 2005.11.3. eg. tzEntry[i].name: "+00 2". 
		   tzEntry[] in router/rc/ntp.h 
		   and time_map[] in router/busybox/syslogd.c are very important */
		if(!strncmp(trim_buf, tzEntry[i].name, strlen(tzEntry[i].name)))
			break;
		if( near_index==-1 && tz==atoi(tmp) ) near_index=i;
	}

	if( i==tzEntrySize ) return near_index;
	return i;
}
