/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************
 
 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.
 
 This software should be used as a reference only, and it not
 intended for production use!

 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <bcmnvram.h>
#include <shutils.h>
#include <utils.h>
#include <rc.h>

#define IGP_DEBUG	0

#if IGP_DEBUG
#define D_PRINTF	printf
#else
#define D_PRINTF(x)	
#endif
int start_igmp_proxy(void)
{
	char enable[3], channel[60];
	pid_t pid;
	int ret = 0;
	char readbuf[256], word[256], *next;

	memset(enable, 0, sizeof(enable));
	memset(channel, 0, sizeof(channel));

	sprintf(enable, "%s", nvram_safe_get("igmp_proxy_enable"));
	if(!strcmp(enable, "0"))
	{
		D_PRINTF("IGMP Proxy Disabled Now !!!\n");
		return 0;
	}

	memset(readbuf, 0, sizeof(readbuf));
	memset(word, 0, sizeof(word));
	if(!file_to_buf("/tmp/status/wan_ifname", readbuf, sizeof(readbuf)))
	{
		printf("No Buf in /tmp/status/wan_ifname !!!\n");
		return 0;
	}
	foreach(word, readbuf, next)
	{
		if(strstr(word, nvram_safe_get("igmp_proxy_channel")))
		{
			sprintf(channel, "%s", word);
			break;
		}
	}

	if(channel)
	{
		char *argv[] = {"IGMPProxy", "-n", channel, NULL};
		D_PRINTF("Now Start IGMP Proxy !!!\n");
		_eval(argv, NULL, 0, &pid);
		stop_firewall();
		start_firewall();
	}
	
	return ret;
}

int stop_igmp_proxy(void)
{
	D_PRINTF("Now Stop IGMP Proxy !!!\n");
	eval("killall", "IGMPProxy");
	return 0;
}

