
/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

/*******************************************************************
*
* FILENAME: igmp_snooping.c
* ABSTRACT: IGMP Snooping Configuration. 
* AUTHOR  : Zhangbin,CyberTAN Technology(GZ),2006-01-10
*
********************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/route.h>
#include "broadcom.h"

/******************************************************************************
*
*NAME              : validate_igmp_snp_config()
*DESCRIPTION       : Validate igmp snooping config and set to nvram. 
*
*INPUTS            : wp		--- web file descriptor.       
		     value	--- vale from web.	
		     v		--- variable for validating.
*OUTPUTS(O)        : NONE
*RETURN            : NONE
*
*modification history
*------------------------------------------------------------------------------
* 1.00, Jan 10, 2006, zhangbin written.
*------------------------------------------------------------------------------
*
*AUTHOR            : zhangbin, CyberTAN Technology(GZ), 2005.1.10
**************************************************************************** */

void validate_igmp_snp_config(webs_t wp, char *value, struct variable *v)
{
	char *enable;

	enable = websGetVar(wp, "igmp_snp_enable", "0");

	nvram_set("igmp_snp_enable", enable);
}

/******************************************************************************
*
*NAME              : ej_igmp_snp_config_setting()
*DESCRIPTION       : display igmp snooping config in web . 
*
*INPUTS            : eid	--- id
		     wp		--- web file descriptor.       
		     argc	--- counts of parameters.
		     argv	--- parameters.
*OUTPUTS(O)        : NONE
*RETURN            : NONE
*
*modification history
*------------------------------------------------------------------------------
* 1.00, Jan 10, 2006, zhangbin written.
*------------------------------------------------------------------------------
*
*AUTHOR            : zhangbin, CyberTAN Technology(GZ), 2005.1.10
**************************************************************************** */

int ej_igmp_snp_config_setting(int eid, webs_t wp, int argc, char_t **argv)
{
	char *arg;
	int count;
	int ret = 0;

	if(ejArgs(argc, argv, "%s %d", &arg, &count) < 2)
	{
		websError(wp, 400, "Insufficient args\n");
		return -1;	
	}

	if(!strcmp(arg, "igmp_snp_enable"))
	{
		char *igmp_snp_enable = nvram_safe_get("igmp_snp_enable");
		
		if((count == 0) && (!strcmp(igmp_snp_enable, "0")))
		{

			return websWrite(wp, "checked");
		}
		if((count == 1) && (!strcmp(igmp_snp_enable, "1")))
		{

			return websWrite(wp, "checked");
		}
	}	
		return ret;
}

