/*
 *********************************************************
 *   Copyright 2003, CyberTAN  Inc.  All Rights Reserved *
 *********************************************************

 This is UNPUBLISHED PROPRIETARY SOURCE CODE of CyberTAN Inc.
 the contents of this file may not be disclosed to third parties,
 copied or duplicated in any form without the prior written
 permission of CyberTAN Inc.

 This software should be used as a reference only, and it not
 intended for production use!


 THIS SOFTWARE IS OFFERED "AS IS", AND CYBERTAN GRANTS NO WARRANTIES OF ANY
 KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE.  CYBERTAN
 SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <net/route.h>

#include "broadcom.h"

#define PRINTD(args...)
#define L2TP_STATIC_ROUTE 20

char *change_str_list(char *str, char *value, int num, char delimp) 
{
    	char *new_str;
    	int i;                      /* pos in str */
    	int cp = 0;                 /* num of delim */
    	int len_value = strlen(value);

   	new_str = (char *) malloc((strlen(str) + len_value + 1) * sizeof(char));    /* allocate a little more */
    	bzero(new_str, strlen(str) + len_value + 1);

    	for (i = 0; (str[i] != '\0') && (cp < num); i++) {
        	if (str[i] == delimp) {
            		cp++;
        	}
    	}

    	if (str[i] == '\0' && cp != num) {
        	free(new_str);
        	return NULL;
    	}

    	strncpy(new_str, str, i);

    	strncat(new_str, value, len_value);

    	if (str[i + 1] == '\0')
        	return new_str;
    	else
        	for (; (str[i] != 0) && (str[i] != delimp); i++);
			strcat(new_str, str + i);
    	return new_str;
}

char *get_str_tab(char *str, int num, int pos, char delimp, char delims) 
{
    	char *new_str;
    	int i, j;                   /* pos in str */
    	int cp = 0, cs = 0;         /* num of delim */
    	int debut = 0;

    	for (i = 0; (str[i] != '\0') && (cp < num); i++) {
        	if (str[i] == delimp) {
            		cp++;
        	}
    	}

    	if (str[i] == '\0') {
        	return NULL;
    	}

    	for (j = 0; (str[i + j] != 0) && (cs < pos); j++) {
        	if (str[i + j] == delims) {
            		cs++;
        	}
    	}

    	if (str[i + j] == 0 && cs != pos) {
        	return NULL;
    	}

    	debut = i + j;

    	for (; (str[i + j] != 0) && (str[i + j] != delimp) && (str[i + j] != delims); j++);

    	new_str = (char *) malloc((i + j - debut + 1) * sizeof(char));
    	bzero(new_str, i + j - debut + 1);

    	strncpy(new_str, str + debut, i + j - debut);

    	return new_str;
}

int ej_show_nat_pool(int eid, webs_t wp, int argc, char_t **argv) 
{
	struct in_addr network_addr;
	struct in_addr netmask_addr;
	struct in_addr eth_addr;
	int num,i;
	unsigned int ip_addr;
	char *str_addr, *tmp;
	char *nat_pool;
		
	if (inet_aton(nvram_safe_get("l2tp_lan_network"), &network_addr) == 0) {
		return 1;
	}
	
	if (inet_aton(nvram_safe_get("l2tp_lan_netmask"), &netmask_addr) == 0) {
		return 1;
	}

	num = (0xFFFFFFFF ^ ntohl(netmask_addr.s_addr))-2;
	
	ip_addr = ntohl(network_addr.s_addr & netmask_addr.s_addr)+1;
	eth_addr.s_addr = htonl(ip_addr);
 	str_addr = inet_ntoa(eth_addr);
 	
 	websWrite(wp, "<TR>\n"
	              "<TD align=right width=156 bgColor=#e7e7e7 colSpan=3 height=1><b>%s</b></TD>\n", str_addr);
 	
 	
	if (inet_aton(nvram_safe_get("lan_ipaddr"), &network_addr) == 0) {
		return 1;
	}
	if (inet_aton(nvram_safe_get("lan_netmask"), &netmask_addr) == 0) {
		return 1;
	}
	
	eth_addr.s_addr = netmask_addr.s_addr & network_addr.s_addr;
	str_addr = inet_ntoa(eth_addr);

	websWrite(wp, "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>\n"
      			  "<TD width=14 height=25>&nbsp;</TD>\n"
      			  "<TD width=17 height=25>&nbsp;</TD>\n"
                  "<TD width=100 height=25><script>Capture(setl2tp.network)</script></TD>\n"
                  "<TD width=310 height=25><INPUT disabled style=\"FONT-SIZE: 10pt; FONT-FAMILY: Arial\" maxLength=17 size=17 value='%s' ></TD>\n"
                  "<TD width=13 height=25>&nbsp;</TD>\n"
                  "<TD width=15 background=image/UI_05.gif height=25>&nbsp;</TD>\n"
                  "</TR>\n", str_addr);
    websWrite(wp, "<TR>\n"
                  "<TD align=right width=156 bgColor=#e7e7e7 colSpan=3 height=1></TD>\n"
                  "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>\n"
                  "<TD width=14 height=25>&nbsp;</TD>\n"
                  "<TD width=17 height=25>&nbsp;</TD>\n"
                  "<TD width=100 height=25><script>Capture(setl2tp.netmask)</script></TD>\n"
                  "<TD width=310 height=25><INPUT disabled  style=\"FONT-SIZE: 10pt; FONT-FAMILY: Arial\" maxLength=17 size=17 value='%s' ></TD>\n"
		          "<TD width=13 height=25>&nbsp;</TD>\n"
                  "<TD width=15 background=image/UI_05.gif height=25>&nbsp;</TD>\n"
			      "</TR>\n", nvram_safe_get("lan_netmask"));
    websWrite(wp, "<TR>\n"
                  "<TD align=right width=156 bgColor=#e7e7e7 colSpan=3 height=1></TD>\n"
                  "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>\n"
                  "<TD width=14 height=25>&nbsp;</TD>\n"
                  "<TD width=17 height=25>&nbsp;</TD>\n"
                  "<TD width=100 height=25><script>Capture(setl2tp.lan)</script></TD>\n"
                  "<TD width=310 height=25><INPUT disabled style=\"FONT-SIZE: 10pt; FONT-FAMILY: Arial\" maxLength=17 size=17 value='%s' ></TD>\n"
		          "<TD width=13 height=25>&nbsp;</TD>\n"
                  "<TD width=15 background=image/UI_05.gif height=25>&nbsp;</TD>\n"
			      "</TR>\n", nvram_safe_get("lan_ipaddr"));
	websWrite(wp, "<TR>"
                  "<TD width=156 bgColor=#e7e7e7 colSpan=3 height=1></TD>"
                  "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>"
                  "<TD colSpan=2 width=31 height=1>&nbsp;</TD>"
                  "<TD width=410 height=1 colSpan=2> <HR color=#b5b5e6 SIZE=1></TD>"
                  "<TD width=13 height=25>&nbsp;</TD>"
                  "<TD width=15 background=image/UI_05.gif height=1>&nbsp;</TD>"
                  "</TR>");
                      
    ip_addr++;
	
	nat_pool = nvram_safe_get("nat_pool");
	for(i=0;i<num;i++,ip_addr++) {
		eth_addr.s_addr = htonl(ip_addr);
 		str_addr = inet_ntoa(eth_addr);
 		
		tmp = get_str_tab(nat_pool, i, 0, ' ', ':');
 		websWrite(wp, "<TR>\n"
		              "<TD align=right width=156 bgColor=#e7e7e7 colSpan=3 height=1><b>%s</b></TD>\n"
					  "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>\n"
          			  "<TD width=14 height=25>&nbsp;</TD>\n"
          			  "<TD width=17 height=25>&nbsp;</TD>\n"
                      "<TD width=100 height=25><script>Capture(setl2tp.network)</script></TD>\n"
                      "<TD width=310 height=25><INPUT style=\"FONT-SIZE: 10pt; FONT-FAMILY: Arial\" maxLength=17 size=17 name=\"nat_pool_network%d\" value='%s' ></TD>\n"
                      "<TD width=13 height=25>&nbsp;</TD>\n"
                      "<TD width=15 background=image/UI_05.gif height=25>&nbsp;</TD>\n"
                      "</TR>\n", str_addr, i, (tmp == NULL)?"":tmp);
        if (tmp != NULL) {
        	free(tmp);
        }
		tmp = get_str_tab(nat_pool, i, 1, ' ', ':');
        websWrite(wp, "<TR>\n"
                      "<TD align=right width=156 bgColor=#e7e7e7 colSpan=3 height=1></TD>\n"
                      "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>\n"
                      "<TD width=14 height=25>&nbsp;</TD>\n"
                      "<TD width=17 height=25>&nbsp;</TD>\n"
                      "<TD width=100 height=25><script>Capture(setl2tp.netmask)</script>Netmask</TD>\n"
                      "<TD width=310 height=25><INPUT style=\"FONT-SIZE: 10pt; FONT-FAMILY: Arial\" maxLength=17 size=17 name=\"nat_pool_netmask%d\" value='%s' ></TD>\n"
			          "<TD width=13 height=25>&nbsp;</TD>\n"
                      "<TD width=15 background=image/UI_05.gif height=25>&nbsp;</TD>\n"
				      "</TR>\n", i, (tmp == NULL)?"":tmp);
        if (tmp != NULL) {
        	free(tmp);
        }
        tmp = get_str_tab(nat_pool, i, 2, ' ', ':');
        websWrite(wp, "<TR>\n"
                      "<TD align=right width=156 bgColor=#e7e7e7 colSpan=3 height=1></TD>\n"
                      "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>\n"
                      "<TD width=14 height=25>&nbsp;</TD>\n"
                      "<TD width=17 height=25>&nbsp;</TD>\n"
                      "<TD width=100 height=25><script>Capture(setl2tp.lan)</script></TD>\n"
                      "<TD width=310 height=25><INPUT style=\"FONT-SIZE: 10pt; FONT-FAMILY: Arial\" maxLength=17 size=17 name=\"nat_pool_lan%d\" value='%s' ></TD>\n"
			          "<TD width=13 height=25>&nbsp;</TD>\n"
                      "<TD width=15 background=image/UI_05.gif height=25>&nbsp;</TD>\n"
				      "</TR>\n", i, (tmp == NULL)?"":tmp);
        if (tmp != NULL) {
        	free(tmp);
        }
        if (i!= num-1) {
			websWrite(wp, "<TR>"
    	                  "<TD width=156 bgColor=#e7e7e7 colSpan=3 height=1></TD>"
        	              "<TD width=8 background=image/UI_04.gif height=1>&nbsp;</TD>"
            	          "<TD colSpan=2 width=31 height=1>&nbsp;</TD>"
                	      "<TD width=410 height=1 colSpan=2> <HR color=#b5b5e6 SIZE=1></TD>"
                    	  "<TD width=13 height=25>&nbsp;</TD>"
	                      "<TD width=15 background=image/UI_05.gif height=1>&nbsp;</TD>"
    	                  "</TR>");
        }
	}

	return 0;	
}

void validate_nat_pool_config(webs_t wp, char *value, struct variable *v) {
	struct in_addr network_addr;
	struct in_addr netmask_addr;
	struct in_addr lan_addr;
	int num,i;
	char *network, *netmask, *lan;
	char buf[32];
	char *new_nat_pool;
	char null_str[] = "";
		
	printf("entering %s\n", __FUNCTION__);
	
	if (inet_aton(nvram_safe_get("l2tp_lan_network"), &network_addr) == 0) {
		return;
	}
	
	if (inet_aton(nvram_safe_get("l2tp_lan_netmask"), &netmask_addr) == 0) {
		return;
	}

	num = (0xFFFFFFFF ^ ntohl(netmask_addr.s_addr))-2;
	new_nat_pool = (char *) malloc(51 * num * sizeof(char));
	new_nat_pool[0] = 0;
	
	for(i=0;i<num;i++) {
		int blank = 0; 
		snprintf(buf, 32, "nat_pool_network%d", i);
		network = websGetVar(wp, buf, "");
		PRINTD("%s", network);
		if (network[0] != 0) {
			if (inet_aton(network, &network_addr) == 0) {
			goto err;	
			}
		} else {
			blank = 1;	
		}
		snprintf(buf, 32, "nat_pool_netmask%d", i);
		netmask = websGetVar(wp, buf, "");
		PRINTD("%s", netmask);
		if (netmask[0] != 0) {
			if (inet_aton(netmask, &netmask_addr) == 0) {
				goto err;
			}
		} else {
			blank = 1;	
		}

		if (blank) { 
			network = netmask = lan = &null_str[0];
		} else {
			snprintf(buf, 32, "nat_pool_lan%d", i);
			lan = websGetVar(wp, buf, "");
			PRINTD("%s", lan);
			if (lan[0] != 0) {
				if (inet_aton(lan, &lan_addr) == 0) {
					goto err;	
				}
				if ((lan[0] != 0 && netmask[0] != 0 && network[0] != 0) && (lan_addr.s_addr & netmask_addr.s_addr) != (network_addr.s_addr & netmask_addr.s_addr)) {
					PRINTD("");
					goto err;	
				}
			} else {
				if (netmask_addr.s_addr != 0xFFFFFFFF) {
					PRINTD("");
					goto err;
				}	
			}
		}
		
		if (i == 0) {
			snprintf(new_nat_pool, 51*num, "%s:%s:%s", network, netmask, lan);
		} else {
			snprintf(new_nat_pool, 51*num, "%s %s:%s:%s", new_nat_pool, network, netmask, lan);
		}
		PRINTD("%s", new_nat_pool);
	}
	
	nvram_set("nat_pool", new_nat_pool);
	nvram_commit();
	return;

err:
	error_value = 1;
	return;
}


void validate_l2tp_static_route(webs_t wp, char *value, struct variable *v) {
	int page = atoi(websGetVar(wp, "route_page", "0"));
	char *network= websGetVar(wp, "l2tp_network", "");
	char *netmask = websGetVar(wp, "l2tp_netmask", "");
	struct in_addr netmask_addr;
	struct in_addr network_addr;
	char buf[64];
	char *l2tp_route;
	char *new_route;
	
	
	if (network[0] == 0 && netmask[0] == 0){
		return;	
	}
	if ((inet_aton(network, &network_addr) == 0) ||(inet_aton(netmask, &netmask_addr) == 0)) {
		error_value = 1;
		return;
	}
	
	if (network_addr.s_addr &  (netmask_addr.s_addr ^ 0xFFFFFFFF)) {
		error_value = 1;
		return;	
	}

	snprintf(buf, 64, "%s:%s", network, netmask);
	l2tp_route = nvram_safe_get("l2tp_static_route");
	
	PRINTD("%d %s %s", page, buf, l2tp_route);
	
	new_route = change_str_list(l2tp_route, buf, page, ' ');
	if (new_route == NULL) {
		error_value = 1;
		return;
	}
	
	PRINTD("%s", new_route);
	
	nvram_set("l2tp_static_route", new_route);
	nvram_commit();
	free(new_route);

	return;
}

int ej_l2tp_static_route_select(int eid, webs_t wp, int argc, char_t **argv) {
	int i, ret = 0, page;


	page = atoi(websGetVar(wp, "route_page", "0"));	// default to 0
	
	for(i=0 ; i < L2TP_STATIC_ROUTE ; i++){
		ret = websWrite(wp,"\t\t<option value=\"%d\" %s> %d</option>\n",i,(i == page) ? "selected" : "",i+1);
	}

	return ret;
}

int ej_l2tp_get_route(int eid, webs_t wp, int argc, char_t **argv) {
	char *type;
	char *l2tp_route;
	char *page;
	char *net;
	int ret;
	
	if (ejArgs(argc, argv, "%s", &type) < 1) {
    	websError(wp, 400, "Insufficient args\n");
        return -1;
	}
	
	l2tp_route = nvram_safe_get("l2tp_static_route");
	
	page = websGetVar(wp, "route_page", "0");
	
	if (!strcmp(type, "network")) {
		net = get_str_tab(l2tp_route, atoi(page), 0, ' ', ':');
		if (net != NULL) {
			ret = websWrite(wp, "%s", net);
			free(net);
		} else {
			ret = websWrite(wp,"");	
		}
	} else {
		net = get_str_tab(l2tp_route, atoi(page), 1, ' ', ':');
		if (net != NULL) {
			ret = websWrite(wp, "%s", net);
			free(net);
		} else {
			ret = websWrite(wp,"");	
		}
		
	}
	
	return ret;
}

void l2tp_delete_route(webs_t wp) {
	int page = atoi(websGetVar(wp, "route_page", "0"));		
	char *l2tp_route = nvram_safe_get("l2tp_static_route");
	char *new_route;
	
	new_route = change_str_list(l2tp_route, ":", page, ' ');
	
	if (new_route != NULL) {
		nvram_set("l2tp_static_route", new_route);
		nvram_commit();
		free(new_route);	
	}
}
