/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <paths.h>
#include <signal.h>
#include <stdarg.h>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/param.h>

#define nvram_safe_get(name) (nvram_get_co(name)?:"")

#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>
#include <utils.h>

/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include "ucd-snmp-config.h"
#include "ucd-snmp-includes.h"
#include "ucd-snmp-agent-includes.h"


#endif /* !IN_UCD_SNMP_SOURCE */


#include "common.h"


/* 
 * common_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


struct nvram_convert_co nvram_converts_co[] = {
      { WL("ssid"),           WL0("ssid"),    ""},

        { WL("radio"),          WL0("mode"),    ""},

        { WL("mode"),           WL0("mode"),    ""},
        { WL("wds"),            WL0("wds"),     ""},
        { WL("auth"),           WL0("auth"),    ""},
        { WL("key"),            WL0("key"),     ""},
        { WL("key1"),           WL0("key1"),    ""},
        { WL("key2"),           WL0("key2"),    ""},
        { WL("key3"),           WL0("key3"),    ""},
        { WL("key4"),           WL0("key4"),    ""},
        { WL("maclist"),        WL0("maclist"), ""},
        { WL("channel"),        WL0("channel"), D11G("channel")},
        { WL("rateset"),        WL0("rateset"), D11G("rateset")},
        { WL("rts"),            WL0("rts"),     D11G("rts")},
        { WL("bcn"),            WL0("bcn"),     D11G("bcn")},
        { WL("gmode"),          WL0("gmode"),   "d11g_mode"},
        { WL("unit"),           WL0("unit"),    ""},
        { WL("ifname"),         WL0("ifname"),  ""},
        { WL("phytype"),        WL0("phytype"), ""},
        { WL("country"),        WL0("country"), ""},
        { WL("closed"),         WL0("closed"),  ""},
        { WL("lazywds"),        WL0("lazywds"), ""},
        { WL("wep"),            WL0("wep"),     ""},
        { WL("macmode"),        WL0("macmode"), ""},
        { WL("rate"),           WL0("rate"),    D11G("rate")},
        { WL("frag"),           WL0("frag"),    D11G("frag")},
        { WL("dtim"),           WL0("dtim"),    D11G("dtim")},
        { WL("plcphdr"),        WL0("plcphdr"), ""},
        { WL("gmode_protection"),       WL0("gmode_protection"),        ""},
        { WL("auth_mode"),      WL0("auth_mode"),       ""},
        { WL("radius_ipaddr"),  WL0("radius_ipaddr"),   ""},
        { WL("radius_port"),    WL0("radius_port"),     ""},
        { WL("radius_key"),     WL0("radius_key"),      ""},
        { WL("wpa_psk"),        WL0("wpa_psk"),         ""},
        { WL("wpa_gtk_rekey"),  WL0("wpa_gtk_rekey"),   ""},
        { WL("frameburst"),     WL0("frameburst"),      ""},
        { PPP("username"),      PPPOE("username"),      ""},
        { PPP("passwd"),        PPPOE("passwd"),        ""},
        { PPP("idletime"),      PPPOE("idletime"),      ""},
        { PPP("keepalive"),     PPPOE("keepalive"),     ""},
        { PPP("demand"),        PPPOE("demand"),        ""},
        { PPP("service"),       PPPOE("service"),       ""},
        { PPP("ac"),            PPPOE("ac"),            ""},
        { PPP("static"),        PPPOE("static"),        ""},
        { PPP("static_ip"),     PPPOE("static_ip"),     ""},
        { PPP("username_1"),    PPPOE("username_1"),    ""},
        { PPP("passwd_1"),      PPPOE("passwd_1"),      ""},
        { PPP("idletime_1"),    PPPOE("idletime_1"),    ""},
        { PPP("keepalive_1"),   PPPOE("keepalive_1"),   ""},
        { PPP("demand_1"),      PPPOE("demand_1"),      ""},
        { PPP("service_1"),     PPPOE("service_1"),     ""},
        { PPP("ac_1"),          PPPOE("ac_1"),          ""},

        { 0, 0, 0},
};


int nvram_fd_co=-1;
oid common_variables_oid[] = { 1,3,6,1,4,1,3955,1 };


/* 
 * variable2 common_variables:
 *   this variable defines function callbacks and type return information 
 *   for the common mib section 
 */


struct variable2 common_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   COMMONFIRMWAREVER     1
  { COMMONFIRMWAREVER   , ASN_OCTET_STR , RONLY , var_common, 1, { 1 } },
#define   COMMONMODELID         2
  { COMMONMODELID       , ASN_OCTET_STR , RONLY , var_common, 1, { 4 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_common():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_common(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("common", common_variables, variable2,
               common_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_common():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_common(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;

  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {

    case COMMONFIRMWAREVER:
        
        *string = 0;
	sprintf(&string,"%s",nvram_safe_get("software_version"));
        *var_len = strlen(string)-1;
        return (unsigned char *) string+1;
    
    case COMMONMODELID:
        *string = 0;
        sprintf(&string,"%s",nvram_safe_get("hardware_version"));	
        *var_len = strlen(string)-1;
        return (unsigned char *) string+1;


    default:
      ERROR_MSG("");
  }
  return NULL;
}

int
nvram_init_co(void *unused)
{

       if ((nvram_fd_co = open(PATH_DEV_NVRAM, O_RDWR)) < 0)
                       goto err;
        return 0;
  err:
        perror(PATH_DEV_NVRAM);
       return errno;
}

 char *
   nvram_get_co(const char *name)
{

       size_t count = strlen(name) + 1;
       char *off;
       memset((void *)nvram_value_co, 0, MAX_LEN);
       off = (char *)nvram_value_co;
       if (nvram_fd_co < 0)
	           if (nvram_init_co(NULL))
		                    return NULL;
       strcpy((char *) off, name);
       count = read(nvram_fd_co, off, count);
       return off;
}
int
nvram_set_co(const char *name, const char *value)
{

//       struct nvram_convert nvram_converts[];
       struct nvram_convert_co *v;
       int ret;
       ret = _nvram_set_co(name, value);
       for(v = nvram_converts_co ; v->name ; v++) {
         if(!strcmp(v->name, name)){
           if(strcmp(v->wl0_name,""))      _nvram_set_co(v->wl0_name, value);
           if(strcmp(v->d11g_name,""))     _nvram_set_co(v->d11g_name, value);
         }

       }
       return ret;
}
static int
_nvram_set_co(const char *name, const char *value)
{

        size_t count = strlen(name) + 1;
        char tmp[100], *buf = tmp;
        int ret;

        if (nvram_fd_co < 0)
	           if ((ret = nvram_init_co(NULL)))
		                  return ret;
       /* Unset if value is NULL */
        if (value)
	           count += strlen(value) + 1;
        if (count > sizeof(tmp)) {
	           if (!(buf = malloc(count)))
		                  return -ENOMEM;
	         }
        if (value)
	           sprintf(buf, "%s=%s", name, value);
        else
	           strcpy(buf, name);
        ret = write(nvram_fd_co, buf, count);
        if (ret < 0)

           perror(PATH_DEV_NVRAM);
        if (buf != tmp)
	           free(buf);

        return (ret == count) ? 0 : ret;
}	






