/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <paths.h>
#include <signal.h>
#include <stdarg.h>

#include <sys/types.h>
#include <sys/un.h>
#include <sys/param.h>

#define nvram_safe_get(name) (nvram_get_wi(name)?:"")
//#include <cy_conf.h>>
#include <config.h>

#define ASSOCLIST_TMP	"/tmp/.wl_assoclist"
#define OLD_NAME_IP	"/tmp/.old_name_ip"
#define ASSOCLIST_CMD	"wl assoclist"

#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include "ucd-snmp-config.h"
#include "ucd-snmp-includes.h"
#include "ucd-snmp-agent-includes.h"


#endif /* !IN_UCD_SNMP_SOURCE */


#include "wirelessMgt.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
/* 
 * wirelessMgt_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


struct nvram_convert_wi nvram_converts_wi[] = {
     { WL("ssid"),           WL0("ssid"),    ""},

        { WL("radio"),          WL0("mode"),    ""},
        { WL("mode"),           WL0("mode"),    ""},
        { WL("wds"),            WL0("wds"),     ""},
        { WL("auth"),           WL0("auth"),    ""},
        { WL("key"),            WL0("key"),     ""},
        { WL("key1"),           WL0("key1"),    ""},
        { WL("key2"),           WL0("key2"),    ""},
        { WL("key3"),           WL0("key3"),    ""},
        { WL("key4"),           WL0("key4"),    ""},
        { WL("maclist"),        WL0("maclist"), ""},
        { WL("channel"),        WL0("channel"), D11G("channel")},
        { WL("rateset"),        WL0("rateset"), D11G("rateset")},
        { WL("rts"),            WL0("rts"),     D11G("rts")},
        { WL("bcn"),            WL0("bcn"),     D11G("bcn")},
        { WL("gmode"),          WL0("gmode"),   "d11g_mode"},
        { WL("unit"),           WL0("unit"),    ""},
        { WL("ifname"),         WL0("ifname"),  ""},
        { WL("phytype"),        WL0("phytype"), ""},
        { WL("country"),        WL0("country"), ""},

        { WL("closed"),         WL0("closed"),  ""},
        { WL("lazywds"),        WL0("lazywds"), ""},
        { WL("wep"),            WL0("wep"),     ""},
        { WL("macmode"),        WL0("macmode"), ""},
        { WL("rate"),           WL0("rate"),    D11G("rate")},
        { WL("frag"),           WL0("frag"),    D11G("frag")},
        { WL("dtim"),           WL0("dtim"),    D11G("dtim")},
        { WL("plcphdr"),        WL0("plcphdr"), ""},
        { WL("gmode_protection"),       WL0("gmode_protection"),        ""},
        { WL("auth_mode"),      WL0("auth_mode"),       ""},
        { WL("radius_ipaddr"),  WL0("radius_ipaddr"),   ""},
        { WL("radius_port"),    WL0("radius_port"),     ""},
        { WL("radius_key"),     WL0("radius_key"),      ""},
        { WL("wpa_psk"),        WL0("wpa_psk"),         ""},
        { WL("wpa_gtk_rekey"),  WL0("wpa_gtk_rekey"),   ""},
        { WL("frameburst"),     WL0("frameburst"),      ""},
        { PPP("username"),      PPPOE("username"),      ""},
        { PPP("passwd"),        PPPOE("passwd"),        ""},
        { PPP("idletime"),      PPPOE("idletime"),      ""},
        { PPP("keepalive"),     PPPOE("keepalive"),     ""},
        { PPP("demand"),        PPPOE("demand"),        ""},
        { PPP("service"),       PPPOE("service"),       ""},
        { PPP("ac"),            PPPOE("ac"),            ""},
        { PPP("static"),        PPPOE("static"),        ""},

        { PPP("static_ip"),     PPPOE("static_ip"),     ""},
        { PPP("username_1"),    PPPOE("username_1"),    ""},
        { PPP("passwd_1"),      PPPOE("passwd_1"),      ""},
        { PPP("idletime_1"),    PPPOE("idletime_1"),    ""},
        { PPP("keepalive_1"),   PPPOE("keepalive_1"),   ""},
        { PPP("demand_1"),      PPPOE("demand_1"),      ""},
        { PPP("service_1"),     PPPOE("service_1"),     ""},
        { PPP("ac_1"),          PPPOE("ac_1"),          ""},

        { 0, 0, 0},
};

int nvram_fd_wi=-1;
oid wirelessMgt_variables_oid[] = { 1,3,6,1,4,1,3955,2,6 };


/* 
 * variable4 wirelessMgt_variables:
 *   this variable defines function callbacks and type return information 
 *   for the wirelessMgt mib section 
 */


struct variable4 wirelessMgt_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   STATIONMACFILTER      1
  { STATIONMACFILTER    , ASN_INTEGER   , RWRITE , var_wirelessMgt, 2, { 1,1 } },
#define   NETWORKMODE           2
  { NETWORKMODE         , ASN_INTEGER   , RWRITE , var_wirelessMgt, 2, { 1,2 } },
#define   APBRIDGEMACINDEX      3
  { APBRIDGEMACINDEX    , ASN_INTEGER   , RONLY , var_apBridgeMacTable, 4, { 1,7,1,1 } },
#define   APBRIDGEMACADDRESS    4
  { APBRIDGEMACADDRESS  , ASN_OCTET_STR , RWRITE, var_apBridgeMacTable, 4, { 1,7,1,2 } },
#define   IEEE80211BBROADCASTSSID  5
  { IEEE80211BBROADCASTSSID, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 2,1 } },
#define   IEEE80211BSSIDSTRING  6
  { IEEE80211BSSIDSTRING, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,2 } },
#define   IEEE80211BCHANNEL     7
  { IEEE80211BCHANNEL   , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 2,3 } },
#define   IEEE80211BWEP         8
  { IEEE80211BWEP       , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 2,4 } },
#define   IEEE80211BWEPAUTHMETHOD  9
  { IEEE80211BWEPAUTHMETHOD, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 2,5 } },
#define   IEEE80211BWEPBITS     10
  { IEEE80211BWEPBITS   , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 2,6 } },
#define   IEEE80211BDEFAULTKEY  11
  { IEEE80211BDEFAULTKEY, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 2,7 } },
#define   IEEE80211BWEP64BITKEY1  12
  { IEEE80211BWEP64BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,8 } },
#define   IEEE80211BWEP64BITKEY2  13
  { IEEE80211BWEP64BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,9 } },
#define   IEEE80211BWEP64BITKEY3  14
  { IEEE80211BWEP64BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,10 } },
#define   IEEE80211BWEP64BITKEY4  15
  { IEEE80211BWEP64BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,11 } },
#define   IEEE80211BWEP128BITKEY1  16
  { IEEE80211BWEP128BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,12 } },
#define   IEEE80211BWEP128BITKEY2  17
  { IEEE80211BWEP128BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,13 } },
#define   IEEE80211BWEP128BITKEY3  18
  { IEEE80211BWEP128BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,14 } },
#define   IEEE80211BWEP128BITKEY4  19
  { IEEE80211BWEP128BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 2,15 } },
/*
#define   IEEE80211ABROADCASTSSID  20
  { IEEE80211ABROADCASTSSID, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 3,1 } },
#define   IEEE80211ASSIDSTRING  21
  { IEEE80211ASSIDSTRING, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,2 } },
#define   IEEE80211ACHANNEL     22
  { IEEE80211ACHANNEL   , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 3,3 } },
#define   IEEE80211AWEP         23
  { IEEE80211AWEP       , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 3,4 } },
#define   IEEE80211AWEPAUTHMETHOD  24
  { IEEE80211AWEPAUTHMETHOD, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 3,5 } },
#define   IEEE80211ADEFAULTKEY  25
  { IEEE80211ADEFAULTKEY, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 3,6 } },
#define   IEEE80211AWEPBITS     26
  { IEEE80211AWEPBITS   , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 3,7 } },
#define   IEEE80211AWEP64BITKEY1  27
  { IEEE80211AWEP64BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,8 } },
#define   IEEE80211AWEP64BITKEY2  28
  { IEEE80211AWEP64BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,9 } },
#define   IEEE80211AWEP64BITKEY3  29
  { IEEE80211AWEP64BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,10 } },
#define   IEEE80211AWEP64BITKEY4  30
  { IEEE80211AWEP64BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,11 } },
#define   IEEE80211AWEP128BITKEY1  31
  { IEEE80211AWEP128BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,12 } },
#define   IEEE80211AWEP128BITKEY2  32
  { IEEE80211AWEP128BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,13 } },
#define   IEEE80211AWEP128BITKEY3  33
  { IEEE80211AWEP128BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,14 } },
#define   IEEE80211AWEP128BITKEY4  34
  { IEEE80211AWEP128BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,15 } },
#define   IEEE80211AWEP152BITKEY1  35
  { IEEE80211AWEP152BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,16 } },
#define   IEEE80211AWEP152BITKEY2  36
  { IEEE80211AWEP152BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,17 } },
#define   IEEE80211AWEP152BITKEY3  37
  { IEEE80211AWEP152BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,18 } },
#define   IEEE80211AWEP152BITKEY4  38
  { IEEE80211AWEP152BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 3,19 } },
*/
#define   IEEE80211GBROADCASTSSID  39
  { IEEE80211GBROADCASTSSID, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,1 } },
#define   IEEE80211GSSIDSTRING  40
  { IEEE80211GSSIDSTRING, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,2 } },
#define   IEEE80211GCHANNEL     41
  { IEEE80211GCHANNEL   , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,3 } },
#define   IEEE80211GWEP         42
  { IEEE80211GWEP       , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,4 } },
#define   IEEE80211GWEPAUTHMETHOD  43
  { IEEE80211GWEPAUTHMETHOD, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,5 } },
#define   IEEE80211GWEPBITS     44
  { IEEE80211GWEPBITS   , ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,6 } },
#define   IEEE80211GDEFAULTKEY  45
  { IEEE80211GDEFAULTKEY, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,7 } },
#define   IEEE80211GWEP64BITKEY1  46
  { IEEE80211GWEP64BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,8 } },
#define   IEEE80211GWEP64BITKEY2  47
  { IEEE80211GWEP64BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,9 } },
#define   IEEE80211GWEP64BITKEY3  48
  { IEEE80211GWEP64BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,10 } },
#define   IEEE80211GWEP64BITKEY4  49
  { IEEE80211GWEP64BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,11 } },
#define   IEEE80211GWEP128BITKEY1  50
  { IEEE80211GWEP128BITKEY1, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,12 } },
#define   IEEE80211GWEP128BITKEY2  51
  { IEEE80211GWEP128BITKEY2, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,13 } },
#define   IEEE80211GWEP128BITKEY3  52
  { IEEE80211GWEP128BITKEY3, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,14 } },
#define   IEEE80211GWEP128BITKEY4  53
  { IEEE80211GWEP128BITKEY4, ASN_OCTET_STR , RWRITE, var_wirelessMgt, 2, { 4,15 } },
#define   IEEE80211GNETWORKMODE  54
  { IEEE80211GNETWORKMODE, ASN_INTEGER   , RWRITE, var_wirelessMgt, 2, { 4,30 } },
//#define   WIRELESSWPAINDEX       55
//  { WIRELESSWPAINDEX, ASN_INTEGER   , RONLY, var_wirelessWPATable, 4, { 5,1,1,1 } },
//#define   WIRELESSWPAALGORITHM   56
//  { WIRELESSWPAALGORITHM, ASN_INTEGER   , RWRITE, var_wirelessWPATable, 4, { 5,1,1,2 } },
//#define   WIRELESSWPASHAREDKEY   57
//  { WIRELESSWPASHAREDKEY, ASN_OCTET_STR  , RWRITE, var_wirelessWPATable, 4, { 5,1,1,3 } },
//#define   WIRELESSGROUPKEYRENEWAL  58
//using this one  { WIRELESSGROUPKEYRENEWAL, ASN_INTEGER   , RWRITE, var_wirelessWPATable, 4, { 5,1,1,4 } },
// not use { WIRELESSGROUPKEYRENEWAL, ASN_OCTET_STR   , RWRITE, var_wirelessWPATable, 4, { 5,1,1,4 } },

#define   WIRELESSCONNECTIONINDEX  59
  { WIRELESSCONNECTIONINDEX, ASN_INTEGER   , RONLY, var_wirelessConnectionTable, 3, { 6,1,1 } },
#define   WIRELESSCONNECTIONMAC  60
  { WIRELESSCONNECTIONMAC, ASN_OCTET_STR   , RONLY, var_wirelessConnectionTable, 3, { 6,1,2 } },



};
/*    (L = length of the oidsuffix) */


/*
 * init_wirelessMgt():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_wirelessMgt(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("wirelessMgt", wirelessMgt_variables, variable4,
               wirelessMgt_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_wirelessMgt():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_wirelessMgt(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {

    
    case STATIONMACFILTER:
//      *write_method = write_ieee80211bBroadcastSSID;
        long_ret = 1;
//#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ STSTIONMACFILTER = [%s] ++++\r\n", nvram_safe_get("wl_macmode1"));
//#endif
	if( !strcmp("other",nvram_safe_get("wl_macmode1") ) )
	{
		long_ret = 1;
	}	
	else if( !strcmp("disabled",nvram_safe_get("wl_macmode1") ) )
	{
		long_ret = 0;
	}	
	
        return (unsigned char *) &long_ret;

    case NETWORKMODE:
//        *write_method = write_ieee80211bBroadcastSSID;
        long_ret = 1;
//	long_ret = atoi(nvram_safe_get("wl_closed"));
//#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ NETWORKMODE = [%s] ++++\r\n", nvram_safe_get("wl_net_mode") );
//#endif
        *write_method = write_ieee80211gNetworkMode;
        long_ret = 0;
	if( !strcmp("disabled",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 0;
	else if( !strcmp("b-only",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 1;
	else if( !strcmp("g-only",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 2;
	else if( !strcmp("mixed",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 3;
        return (unsigned char *) &long_ret;

    case IEEE80211BBROADCASTSSID:
        *write_method = write_ieee80211bBroadcastSSID;
        long_ret = 1;
	long_ret = atoi(nvram_safe_get("wl_closed"));
	if( long_ret == 0 )
		long_ret = 1;
	else if( long_ret == 1 )
		long_ret = 0;
//#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ IEEE80211BBROADCASTSSID = [%s] ++++\r\n", nvram_safe_get("wl_closed") );
//#endif
        return (unsigned char *) &long_ret;

    case IEEE80211BSSIDSTRING:
        *write_method = write_ieee80211bSSIDString;
//        *string = 0;
	sprintf(string, "%s", nvram_safe_get("wl_ssid"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BCHANNEL:
        *write_method = write_ieee80211bChannel;
        long_ret = 0;
	long_ret = atoi(nvram_safe_get("wl_channel"));
        return (unsigned char *) &long_ret;

    case IEEE80211BWEP:
        *write_method = write_ieee80211bWep;
        long_ret = 0;
	if( !strcmp("wep",nvram_safe_get("security_mode") ) )
        	long_ret = 1;
	else 
        	long_ret = 0;
	
        return (unsigned char *) &long_ret;

    case IEEE80211BWEPAUTHMETHOD:
        *write_method = write_ieee80211bWepAuthMethod;
        long_ret = 0;
	if( !strcmp("0",nvram_safe_get("wl_auth") ) )
        	long_ret = 0;
	else if( !strcmp("1",nvram_safe_get("wl_auth") ) )
        	long_ret = 2;
        return (unsigned char *) &long_ret;

    case IEEE80211BWEPBITS:
        *write_method = write_ieee80211bWepBits;
        long_ret = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
        	long_ret = 0;
	else if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
        	long_ret = 1;
        return (unsigned char *) &long_ret;

    case IEEE80211BDEFAULTKEY:
        *write_method = write_ieee80211bDefaultKey;
        long_ret = 0;
	if( !strcmp("1",nvram_safe_get("wl_key") ) )
        	long_ret = 1;
	else if( !strcmp("2",nvram_safe_get("wl_key") ) )
        	long_ret = 2;
	else if( !strcmp("3",nvram_safe_get("wl_key") ) )
        	long_ret = 3;
	else if( !strcmp("4",nvram_safe_get("wl_key") ) )
        	long_ret = 4;
        return (unsigned char *) &long_ret;

    case IEEE80211BWEP64BITKEY1:
        *write_method = write_ieee80211bWep64bitkey1;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key1"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP64BITKEY2:
        *write_method = write_ieee80211bWep64bitkey2;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key2"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP64BITKEY3:
        *write_method = write_ieee80211bWep64bitkey3;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key3"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP64BITKEY4:
        *write_method = write_ieee80211bWep64bitkey4;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key4"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP128BITKEY1:
        *write_method = write_ieee80211bWep128bitkey1;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key1"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP128BITKEY2:
        *write_method = write_ieee80211bWep128bitkey2;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key2"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP128BITKEY3:
        *write_method = write_ieee80211bWep128bitkey3;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key3"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211BWEP128BITKEY4:
        *write_method = write_ieee80211bWep128bitkey4;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key4"));
        *var_len = strlen(string);
        return (unsigned char *) string;
/*

    case IEEE80211ABROADCASTSSID:
        *write_method = write_ieee80211aBroadcastSSID;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211ASSIDSTRING:
        *write_method = write_ieee80211aSSIDString;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211ACHANNEL:
        *write_method = write_ieee80211aChannel;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211AWEP:
        *write_method = write_ieee80211aWep;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211AWEPAUTHMETHOD:
        *write_method = write_ieee80211aWepauthmethod;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211ADEFAULTKEY:
        *write_method = write_ieee80211aDefaultKey;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211AWEPBITS:
        *write_method = write_ieee80211aWepbits;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211AWEP64BITKEY1:
        *write_method = write_ieee80211aWep64bitkey1;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP64BITKEY2:
        *write_method = write_ieee80211aWep64bitkey2;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP64BITKEY3:
        *write_method = write_ieee80211aWep64bitkey3;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP64BITKEY4:
        *write_method = write_ieee80211aWep64bitkey4;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP128BITKEY1:
        *write_method = write_ieee80211aWep128bitkey1;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP128BITKEY2:
        *write_method = write_ieee80211aWep128bitkey2;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP128BITKEY3:
        *write_method = write_ieee80211aWep128bitkey3;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP128BITKEY4:
        *write_method = write_ieee80211aWep128bitkey4;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP152BITKEY1:
        *write_method = write_ieee80211aWep152bitkey1;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP152BITKEY2:
        *write_method = write_ieee80211aWep152bitkey2;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP152BITKEY3:
        *write_method = write_ieee80211aWep152bitkey3;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211AWEP152BITKEY4:
        *write_method = write_ieee80211aWep152bitkey4;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;
*/
//-----------------------------------------------
    case IEEE80211GBROADCASTSSID:
        *write_method = write_ieee80211bBroadcastSSID;
        long_ret = 1;
	long_ret = atoi(nvram_safe_get("wl_closed"));
	if( long_ret == 0 )
		long_ret = 1;
	else if( long_ret == 1 )
		long_ret = 0;
//#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ IEEE80211BBROADCASTSSID = [%s] ++++\r\n", nvram_safe_get("wl_closed") );
	fprintf(stderr,"\r\n++++ long_ret = [%d] ++++\r\n", long_ret );
//#endif
        return (unsigned char *) &long_ret;

    case IEEE80211GSSIDSTRING:
        *write_method = write_ieee80211bSSIDString;
//        *string = 0;
	sprintf(string, "%s", nvram_safe_get("wl_ssid"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GCHANNEL:
        *write_method = write_ieee80211bChannel;
        long_ret = 0;
	long_ret = atoi(nvram_safe_get("wl_channel"));
        return (unsigned char *) &long_ret;

    case IEEE80211GWEP:
        *write_method = write_ieee80211bWep;
        long_ret = 0;
	if( !strcmp("wep",nvram_safe_get("security_mode") ) )
        	long_ret = 1;
	else 
        	long_ret = 0;
	
        return (unsigned char *) &long_ret;

    case IEEE80211GWEPAUTHMETHOD:
        *write_method = write_ieee80211bWepAuthMethod;
        long_ret = 0;
	if( !strcmp("0",nvram_safe_get("wl_auth") ) )
        	long_ret = 0;
	else if( !strcmp("1",nvram_safe_get("wl_auth") ) )
        	long_ret = 2;
        return (unsigned char *) &long_ret;

    case IEEE80211GWEPBITS:
        *write_method = write_ieee80211bWepBits;
        long_ret = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
        	long_ret = 0;
	else if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
        	long_ret = 1;
        return (unsigned char *) &long_ret;

    case IEEE80211GDEFAULTKEY:
        *write_method = write_ieee80211bDefaultKey;
        long_ret = 0;
	if( !strcmp("1",nvram_safe_get("wl_key") ) )
        	long_ret = 1;
	else if( !strcmp("2",nvram_safe_get("wl_key") ) )
        	long_ret = 2;
	else if( !strcmp("3",nvram_safe_get("wl_key") ) )
        	long_ret = 3;
	else if( !strcmp("4",nvram_safe_get("wl_key") ) )
        	long_ret = 4;
        return (unsigned char *) &long_ret;

    case IEEE80211GWEP64BITKEY1:
        *write_method = write_ieee80211bWep64bitkey1;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key1"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP64BITKEY2:
        *write_method = write_ieee80211bWep64bitkey2;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key2"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP64BITKEY3:
        *write_method = write_ieee80211bWep64bitkey3;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key3"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP64BITKEY4:
        *write_method = write_ieee80211bWep64bitkey4;
        *string = 0;
	if( !strcmp("64",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key4"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY1:
        *write_method = write_ieee80211bWep128bitkey1;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key1"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY2:
        *write_method = write_ieee80211bWep128bitkey2;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key2"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY3:
        *write_method = write_ieee80211bWep128bitkey3;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key3"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY4:
        *write_method = write_ieee80211bWep128bitkey4;
        *string = 0;
	if( !strcmp("128",nvram_safe_get("wl_wep_bit") ) )
		sprintf(string, "%s", nvram_safe_get("wl_key4"));
        *var_len = strlen(string);
        return (unsigned char *) string;



//-----------------------------------------------
/*
    case IEEE80211GBROADCASTSSID:
        *write_method = write_ieee80211gBroadcastSSID;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211GSSIDSTRING:
        *write_method = write_ieee80211gSSIDString;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GCHANNEL:
        *write_method = write_ieee80211gChannel;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211GWEP:
        *write_method = write_ieee80211gWep;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211GWEPAUTHMETHOD:
        *write_method = write_ieee80211gWepAuthMethod;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211GWEPBITS:
        *write_method = write_ieee80211gWepBits;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211GDEFAULTKEY:
        *write_method = write_ieee80211gDefaultKey;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case IEEE80211GWEP64BITKEY1:
        *write_method = write_ieee80211gWep64bitkey1;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP64BITKEY2:
        *write_method = write_ieee80211gWep64bitkey2;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP64BITKEY3:
        *write_method = write_ieee80211gWep64bitkey3;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP64BITKEY4:
        *write_method = write_ieee80211gWep64bitkey4;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY1:
        *write_method = write_ieee80211gWep128bitkey1;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY2:
        *write_method = write_ieee80211gWep128bitkey2;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY3:
        *write_method = write_ieee80211gWep128bitkey3;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;

    case IEEE80211GWEP128BITKEY4:
        *write_method = write_ieee80211gWep128bitkey4;
        *string = 0;
        *var_len = strlen(string);
        return (unsigned char *) string;
*/
    case IEEE80211GNETWORKMODE:
        *write_method = write_ieee80211gNetworkMode;
        long_ret = 0;
	if( !strcmp("b-only",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 0;
	else if( !strcmp("g-only",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 1;
	else if( !strcmp("mixed",nvram_safe_get("wl_net_mode") ) )
        	long_ret = 2;
        return (unsigned char *) &long_ret;


    default:
      ERROR_MSG("");
  }
  return NULL;
}

/*
 * var_apBridgeMacTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wirelessMgt above.
 */
unsigned char *
var_apBridgeMacTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
//  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
//                                                == MATCH_FAILED )
  if (header_simple_table(vp,name,length,exact,var_len,write_method, 1)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case APBRIDGEMACINDEX:
        
        long_ret = 1;
        return (unsigned char *) &long_ret;

    case APBRIDGEMACADDRESS:
        *write_method = write_apBridgeMacAddress;
        *string = 0;
	sprintf(string, "%s", nvram_safe_get("wl0_hwaddr"));
        *var_len = strlen(string);
        return (unsigned char *) string;


    default:
      ERROR_MSG("");
  }
  return NULL;
}



//-------------------------------------------------------------------------------------
//disable this function var_wirelessWPATable()

#if 0

/*
 * var_wirelessWPATable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wirelessMgt above.
 */
unsigned char *
var_wirelessWPATable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
//  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
//                                                == MATCH_FAILED )
  if (header_simple_table(vp,name,length,exact,var_len,write_method, 1)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case WIRELESSWPAINDEX:
        
        long_ret = 1;
        return (unsigned char *) &long_ret;

    case WIRELESSWPAALGORITHM:

        *write_method = write_wirelessWPAAlgorithm;

#ifdef DEBUG_SNMP       
	fprintf(stderr,"\r\nWIRELESSWPAALGORITHM\r\n"); 
#endif
//	long_ret = 0;
	if( !strcmp("tkip",nvram_safe_get("wl_wep") ) )
	{
		long_ret = 0;
	}
	else if( !strcmp("aes",nvram_safe_get("wl_wep") ) )
	{
		long_ret = 1;
	}
	else 
		long_ret = NULL;
        return (unsigned char *) &long_ret;

    case WIRELESSWPASHAREDKEY:
        
        *write_method = write_wirelessWPASharedkey;
        *string = 0;
	sprintf(string, "%s", nvram_safe_get("wl_wpa_psk"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WIRELESSGROUPKEYRENEWAL:
	
//	fprintf(stderr,"\r\n var_len = [%d] \r\n", *var_len);
        *write_method = write_wirelessGroupkeyRenewal;
	long_ret = 0;
	long_ret = atoi(nvram_safe_get("wl_wpa_gtk_rekey"));
        return (unsigned char *) &long_ret;



    default:
      ERROR_MSG("");
  }
  return NULL;
}


#endif


//disable this function var_wirelessWPATable()
// <-------------------------------------------------------------------------------------


int 
validate_wl_key(char *value)
{
	char *c;

#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n  wep key string = [%s]\r\n",value);
	fprintf(stderr,"\r\n  wep key length = [%d]\r\n",strlen(value));
#endif
	switch (strlen(value)) {
	case 5:
	case 13:			
		break;
	case 10:
	case 26:
		for (c = value; *c; c++) {
			if (!isxdigit(*c)) {
				fprintf(stderr, "Invalid character %c is not a hexadecimal digit", *c);
				return 0;
			}
		}
		break;
	default:
		fprintf(stderr, "Invalid  must be 5 or 13 ASCII characters or 10 or 26 hexadecimal digits");
		fprintf(stderr,"\r\n 2: wep key length = [%d]\r\n",strlen(value));
		return 0;
	}
	return 1;
}
//------------------------------------------------------------------------
int
get_wl_active_mac(int select,char *str1)
{
	char cmd[80], line[80];
	char list[2][20];
	FILE *fp;
	int ret = 0, count=0;

	snprintf(cmd,sizeof(cmd),"%s > %s", ASSOCLIST_CMD, ASSOCLIST_TMP);
	system(cmd);		// get active wireless mac

	if ((fp = fopen(ASSOCLIST_TMP, "r"))) {
		while( fgets(line, sizeof(line), fp) != NULL ) {
			strcpy(list[0],"");
			strcpy(list[1],"");
			if(sscanf(line,"%s %s",list[0],list[1]) != 2)	// assoclist 00:11:22:33:44:55
				continue;
			if(strcmp(list[0],"assoclist"))
				continue;
			if( select == count && select != -1 )
			{	
				sprintf(str1, "%s", list[1] );
			}
			count++;
		}
	}
if ( select == -1 )
	return count;
//	return ret;
}
//------------------------------------------------------------------------




/*
 * var_wirelessConnectionTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wirelessMgt above.
 */
unsigned char *
var_wirelessConnectionTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
  int i=0,j=0;
  static unsigned char s_wan_mac[20];
  static unsigned char i_wan_mac[6];
  int mac_index;
  int TABLE_SIZE=0;
  
  TABLE_SIZE=get_wl_active_mac(-1,NULL);

  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
                                                == MATCH_FAILED )
//  if (header_simple_table(vp,name,length,exact,var_len,write_method, 2)
//                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
	
mac_index = *(name+12)-1;
//fprintf(stderr,"\r\noid index = [%d]: mac index = [%d]\r\n",*(name+11), mac_index);	
  switch(vp->magic) {


    case WIRELESSCONNECTIONINDEX:
        
//        long_ret = 1;
        long_ret = mac_index+1;
        return (unsigned char *) &long_ret;

    case WIRELESSCONNECTIONMAC:
        *string = 0;
	get_wl_active_mac(mac_index,&string);	
//       *var_len = strlen(string);
//------------------------------------------------------
	sprintf(&s_wan_mac, "%s", string);
	j=1;
	for(i=0;i<18;i++)
	{
		if(i==0)
		{
			i_wan_mac[0]=strtol(&s_wan_mac[0],NULL,16);
		}
		else if(s_wan_mac[i]==':')
		{
			i_wan_mac[j]=strtol(&s_wan_mac[i+1],NULL,16);
			j++;
		}
	}
        *var_len = 6;
//        return (unsigned char *) string;
        return (unsigned char *) i_wan_mac;
//------------------------------------------------------

    default:
      ERROR_MSG("");
  }
  return NULL;
}



int
write_apBridgeMacAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to apBridgeMacAddress not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to apBridgeMacAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bBroadcastSSID(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  static long *long_ret;
  int size;

#ifdef DEBUG_SNMP	    
  fprintf(stderr,"\r\n++++ set broadcastSSID [%d] ++++\r\n", *var_val);
#endif
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bBroadcastSSID not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bBroadcastSSID: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          memset(&string,0,sizeof(string));
	  sprintf(&string,"%d",*var_val);	
	  if ( *var_val == 0 )
	          nvram_set_wi("wl_closed", "1");
	  if ( *var_val == 1 )
	          nvram_set_wi("wl_closed", "0");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bSSIDString(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bSSIDString not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bSSIDString: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP
	  fprintf(stderr,"\r\n ++++ setting wl_ssid = [%s]: size = [%d] ++++\r\n", var_val, var_val_len);
#endif
	  snprintf(&string, var_val_len+1, "%s", var_val);	
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n ++++ size of string = [%d] ++++\r\n", strlen(&string));
#endif
          nvram_set_wi("wl_ssid", &string);
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bChannel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bChannel not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bChannel: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP
	  fprintf(stderr,"\r\n ++++ wl_channel = [%d] ++++ \r\n", *var_val);	
#endif
	  if( *var_val >= 1 && *var_val <= 14 )	
	  {
	          memset(&string,0,sizeof(string));
		  sprintf(&string,"%d",*var_val);	
#ifdef DEBUG_SNMP
	  	  fprintf(stderr,"\r\n ++++ setting wl_channel data = [%s] ++++ \r\n", &string);	
#endif
		  nvram_set_wi("wl_channel", &string);
	  }
	  else 
	  {
  		return SNMP_ERR_NOERROR;
	  }		
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bWep not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bWep: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP
	  	  fprintf(stderr,"\r\n++++ wep setting data = [%d] ++++ \r\n", *var_val);
#endif
	  if( *var_val == 1 )	
	  {
		  nvram_set_wi("security_mode","wep");
	  }
	  else if( *var_val == 0 )
          {
		  nvram_set_wi("security_mode","disabled");
          }	
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWepAuthMethod(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bWepAuthMethod not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bWepAuthMethod: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( *var_val == 0 )	
	  {
		  nvram_set_wi("wl_auth","0");
	  }
	  else if( *var_val == 2 || *var_val == 1 )
          {
		  nvram_set_wi("wl_auth","1");
          }	
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWepBits(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bWepBits not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bWepBits: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
 	  if( *var_val == 0 )
	  {
		nvram_set_wi("wl_wep_bit","64");
	  }			
 	  else if( *var_val == 1 )
	  {
		nvram_set_wi("wl_wep_bit","128");
	  }			
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bDefaultKey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bDefaultKey not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bDefaultKey: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( *var_val==1 )
	  {
		nvram_set_wi("wl_key","1");
	  }	
	  if( *var_val==2 )
	  {
		nvram_set_wi("wl_key","2");
	  }	
	  if( *var_val==3 )
	  {
		nvram_set_wi("wl_key","3");
	  }	
	  if( *var_val==4 )
	  {
		nvram_set_wi("wl_key","4");
	  }	
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep64bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep64bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep64bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
#ifdef DEBUG_SNMP
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
#endif
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key1", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep64bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep64bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep64bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key2", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep64bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep64bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep64bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key3", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep64bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep64bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep64bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key4", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep128bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep128bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep128bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key1", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep128bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep128bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep128bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key2", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep128bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep128bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep128bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key3", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211bWep128bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  char buf[200] = "";
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bWep128bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bWep128bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  snprintf(&string, var_val_len+1, "%s", var_val);
	  fprintf(stderr,"\r\n++++  wl_key1 = [%s] ++++\r\n", &string);
          if( validate_wl_key(&string) ) 
	  {
		nvram_set_wi("wl_key4", &string); 			
		strcat(buf,nvram_safe_get("wl_passphrase"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key1"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key2"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key3"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key4"));
		strcat(buf,":");
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		strcat(buf,nvram_safe_get("wl_key"));
		fprintf(stderr,"\r\n++++ buf = [%s] ++++ \r\n", &buf);
		nvram_set_wi("wl_wep_buf", &buf);
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aBroadcastSSID(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211aBroadcastSSID not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211aBroadcastSSID: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aSSIDString(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aSSIDString not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aSSIDString: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aChannel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211aChannel not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211aChannel: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211aWep not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211aWep: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWepauthmethod(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211aWepauthmethod not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211aWepauthmethod: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aDefaultKey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211aDefaultKey not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211aDefaultKey: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWepbits(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211aWepbits not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211aWepbits: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep64bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep64bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep64bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep64bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep64bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep64bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep64bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep64bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep64bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep64bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep64bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep64bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep128bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep128bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep128bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep128bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep128bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep128bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep128bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep128bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep128bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep128bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep128bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep128bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep152bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep152bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep152bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep152bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep152bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep152bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep152bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep152bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep152bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211aWep152bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211aWep152bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211aWep152bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gBroadcastSSID(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gBroadcastSSID not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gBroadcastSSID: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gSSIDString(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gSSIDString not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gSSIDString: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gChannel(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gChannel not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gChannel: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gWep not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gWep: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWepAuthMethod(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gWepAuthMethod not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gWepAuthMethod: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWepBits(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gWepBits not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gWepBits: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gDefaultKey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gDefaultKey not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gDefaultKey: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep64bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep64bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep64bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep64bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep64bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep64bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep64bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep64bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep64bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep64bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep64bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep64bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep128bitkey1(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep128bitkey1 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep128bitkey1: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep128bitkey2(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep128bitkey2 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep128bitkey2: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep128bitkey3(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep128bitkey3 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep128bitkey3: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gWep128bitkey4(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211gWep128bitkey4 not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211gWep128bitkey4: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_ieee80211gNetworkMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211gNetworkMode not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211gNetworkMode: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  fprintf(stderr,"\r\n ++++ setting NetWorkMode = [%d] ++++ \r\n", *var_val);
	  if( *var_val == 0)
 	  {
		nvram_set_wi("wl_net_mode","b-only");
          }
	  else if( *var_val == 1)
 	  {
		nvram_set_wi("wl_net_mode","g-only");
          }
	  else if( *var_val == 2)
 	  {
		nvram_set_wi("wl_net_mode","mixed");
          }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}

int
write_wirelessWPAAlgorithm(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  static long *long_ret;
  int size;

  fprintf(stderr,"\r\n++++ set broadcastSSID [%d] ++++\r\n", *var_val);
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bBroadcastSSID not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bBroadcastSSID: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
//          memset(&string,0,sizeof(string));
//	  sprintf(&string,"%d",*var_val);	
//          nvram_set_wi("wl_closed", &string);
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wirelessWPASharedkey(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to ieee80211bSSIDString not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to ieee80211bSSIDString: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
//#ifdef DEBUG_SNMP
	  fprintf(stderr,"\r\n ++++ setting wl_ssid = [%s]: size = [%d] ++++\r\n", var_val, var_val_len);
//#endif
//	  snprintf(&string, var_val_len+1, "%s", var_val);	
//	  fprintf(stderr,"\r\n ++++ size of string = [%d] ++++\r\n", strlen(&string));
//          nvram_set_wi("wl_ssid", &string);
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}

int
write_wirelessGroupkeyRenewal(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  int *renewal;
  static unsigned char string[SPRINT_MAX_LEN];
  static long *long_ret;
  int size;
  renewal = var_val;
  memset(&string,0,sizeof(string));
  snprintf(&string, var_val_len+1, "%d", *renewal);
#ifdef DEBUG_SNMP
  fprintf(stderr,"\r\n++++ var_val_len [%d] ++++\r\n", var_val_len);
  fprintf(stderr,"\r\n++++ wirelessgroupkeyrenewal [%s] ++++\r\n", &string);
#endif
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to ieee80211bBroadcastSSID not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to ieee80211bBroadcastSSID: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          nvram_set_wi("wl_wpa_gtk_rekey", &string);
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}
int
nvram_init_wi(void *unused)
{
       if ((nvram_fd_wi = open(PATH_DEV_NVRAM, O_RDWR)) < 0)
                       goto err;
        return 0;
  err:
        perror(PATH_DEV_NVRAM);
       return errno;
}
 char *
   nvram_get_wi(const char *name)
{

       size_t count = strlen(name) + 1;
       char *off;
       memset((void *)nvram_value_wi, 0, MAX_LEN);
       off = (char *)nvram_value_wi;
       if (nvram_fd_wi < 0)
	           if (nvram_init_wi(NULL))
		                    return NULL;
       strcpy((char *) off, name);
       count = read(nvram_fd_wi, off, count);
       return off;
}
int
nvram_set_wi(const char *name, const char *value)
{

//       struct nvram_convert nvram_converts[];
       struct nvram_convert_wi *v;
       int ret;
       ret = _nvram_set_wi(name, value);
       for(v = nvram_converts_wi ; v->name ; v++) {
         if(!strcmp(v->name, name)){
           if(strcmp(v->wl0_name,""))      _nvram_set_wi(v->wl0_name, value);
           if(strcmp(v->d11g_name,""))     _nvram_set_wi(v->d11g_name, value);
        }
       }
       return ret;
}
static int
_nvram_set_wi(const char *name, const char *value)
{

        size_t count = strlen(name) + 1;
        char tmp[100], *buf = tmp;
        int ret;

        if (nvram_fd_wi < 0)
	           if ((ret = nvram_init_wi(NULL)))
		                  return ret;
       /* Unset if value is NULL */
        if (value)
	           count += strlen(value) + 1;
        if (count > sizeof(tmp)) {
	           if (!(buf = malloc(count)))
		                  return -ENOMEM;
	         }
        if (value)
	           sprintf(buf, "%s=%s", name, value);
        else
	           strcpy(buf, name);
        ret = write(nvram_fd_wi, buf, count);
        if (ret < 0)
	           perror(PATH_DEV_NVRAM);
        if (buf != tmp)
	           free(buf);

        return (ret == count) ? 0 : ret;
}	





