/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */

#define nvram_safe_get(name) (nvram_get(name)?:"")
#include <cy_conf.h>

#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <ucd-snmp/ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */


#include "advanceMgt.h"


/* 
 * advanceMgt_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid advanceMgt_variables_oid[] = { 1,3,6,1,4,1,3955,2,2 };


/* 
 * variable4 advanceMgt_variables:
 *   this variable defines function callbacks and type return information 
 *   for the advanceMgt mib section 
 */


struct variable4 advanceMgt_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   ADVMGTSNMPSTATUS      1
  { ADVMGTSNMPSTATUS    , ASN_INTEGER   , RWRITE, var_advanceMgt, 1, { 8 } },
#define   TRAPMANAGERINDEX      4
  { TRAPMANAGERINDEX    , ASN_INTEGER   , RONLY , var_trapManagerTable, 3, { 16,1,1 } },
#define   TRAPMGRNETADDRESS     5
  { TRAPMGRNETADDRESS   , ASN_IPADDRESS , RWRITE, var_trapManagerTable, 3, { 16,1,2 } },
#define   TRAPMGRCOMMUNITYNAME  6
  { TRAPMGRCOMMUNITYNAME, ASN_OCTET_STR , RWRITE, var_trapManagerTable, 3, { 16,1,3 } },
#define   ADVMGTUPNPSTATUS      7
  { ADVMGTUPNPSTATUS    , ASN_INTEGER   , RWRITE, var_advanceMgt, 1, { 17 } },

};
/*    (L = length of the oidsuffix) */
/*
int
get_single_ip(char *ipaddr, int which)
{
	int ip[4]={0,0,0,0};
	int ret;

	ret = sscanf(ipaddr,"%d.%d.%d.%d",&ip[0],&ip[1],&ip[2],&ip[3]);

	return ip[which];	
}
*/
/*
 * init_advanceMgt():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_advanceMgt(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("advanceMgt", advanceMgt_variables, variable4,
               advanceMgt_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_advanceMgt():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_advanceMgt(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case ADVMGTSNMPSTATUS:
        *write_method = write_advMgtSNMPStatus;
        long_ret = 1;
	
        return (unsigned char *) &long_ret;

    case ADVMGTUPNPSTATUS:
        *write_method = write_advMgtUPnPStatus;
        long_ret = 0;
	if( !strcmp("1",nvram_safe_get("upnp_enable") ) )
	{
	        long_ret = 1;
	}
	if( !strcmp("0",nvram_safe_get("upnp_enable") ) )
	{
	        long_ret = 0;
	}
        return (unsigned char *) &long_ret;


    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_trapManagerTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_advanceMgt above.
 */
unsigned char *
var_trapManagerTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret , lan_ipaddr;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
	int ip[3]={0,0,0};
        char arg[1000],ip4[1000];


  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
//  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
//                                                == MATCH_FAILED )
  if (header_simple_table(vp,name,length,exact,var_len,write_method, 1)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case TRAPMANAGERINDEX:
        
        long_ret = 1;
        return (unsigned char *) &long_ret;

    case TRAPMGRNETADDRESS:
        *write_method = write_trapMgrNetAddress;
        *string = 0;
	memset(&ip4[0], 0, 1000*sizeof(char));

        ip[0]=get_single_ip(nvram_safe_get("lan_ipaddr"),0);
	ip[1]=get_single_ip(nvram_safe_get("lan_ipaddr"),1);
	ip[2]=get_single_ip(nvram_safe_get("lan_ipaddr"),2);
	
	sprintf(&ip4[0], "%d.%d.%d.%s", ip[0],ip[1],ip[2],nvram_safe_get("trap_dst") );
#ifdef DEBUG_SNMP
	fprintf(stderr, "\r\n%d.%d.%d.%s\r\n", ip[0],ip[1],ip[2],nvram_safe_get("trap_dst") );
#endif
        *var_len = strlen(string);
	*var_len = 4;
        lan_ipaddr = inet_addr(&ip4);
        return (unsigned char *) &lan_ipaddr;

    case TRAPMGRCOMMUNITYNAME:
        *write_method = write_trapMgrCommunityName;
        *string = 0;
	sprintf(&string, "%s",nvram_safe_get("trap_com") );
        *var_len = strlen(string);
        return (unsigned char *) string;


    default:
      ERROR_MSG("");
  }
  return NULL;
}




int
write_advMgtSNMPStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to advMgtSNMPStatus not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to advMgtSNMPStatus: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_trapMgrNetAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


#ifdef DEBUG_SNMP
  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+3));
#endif
  sprintf(&string,"%d", *(var_val+3));

  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
              fprintf(stderr, "write to trapMgrNetAddress not ASN_IPADDRESS\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to trapMgrNetAddress: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  nvram_set("trap_dst", &string);
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_trapMgrCommunityName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;

#ifdef DEBUG_SNMP
  fprintf(stderr,"\r\n ++++ trap_community_name = [%s] ++++\r\n", var_val);
#endif
  snprintf(&string,var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP
  fprintf(stderr,"\r\n ++++ trap_community_name = [%s] ++++\r\n", &string);
#endif
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
              fprintf(stderr, "write to trapMgrCommunityName not ASN_OCTET_STR\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
              fprintf(stderr,"write to trapMgrCommunityName: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  nvram_set("trap_com", &string);
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_advMgtUPnPStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;

#ifdef DEBUG_SNMP
  fprintf(stderr,"\r\n++++ setting upnp [%d] ++++\r\n", *var_val);
#endif
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
              fprintf(stderr, "write to advMgtUPnPStatus not ASN_INTEGER\n");
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
              fprintf(stderr,"write to advMgtUPnPStatus: bad length\n");
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( *var_val == 1 )
	  {
		nvram_set("upnp_enable","1");
	  }
	  else if( *var_val == 0 )
	  {
		nvram_set("upnp_enable","0");
	  }	
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}






