/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */
#define nvram_safe_get(name) (nvram_get(name)?:"")
#ifdef IN_UCD_SNMP_SOURCE

#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <ucd-snmp/ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */

#include <signal.h>
#include <bcmnvram.h>
#include "basicMgt.h"
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


/* 
 * basicMgt_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid basicMgt_variables_oid[] = { 1,3,6,1,4,1,3955,2,1 };


/* 
 * variable4 basicMgt_variables:
 *   this variable defines function callbacks and type return information 
 *   for the basicMgt mib section 
 */


struct variable4 basicMgt_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   MGTSYSTEMRESET        1
  { MGTSYSTEMRESET      , ASN_INTEGER   , RWRITE, var_basicMgt, 1, { 1 } },
#define   MGTFACTORYRESET       2
  { MGTFACTORYRESET     , ASN_INTEGER   , RWRITE, var_basicMgt, 1, { 2 } },
#define   MGTADMINISTRATOR      3
  { MGTADMINISTRATOR    , ASN_OCTET_STR , RWRITE, var_basicMgt, 1, { 3 } },
#define   MGTADMINUSERNAME      4
  { MGTADMINUSERNAME    , ASN_OCTET_STR , RWRITE, var_basicMgt, 1, { 4 } },
#define   MGTSAVECONFIGURATION  5
  { MGTSAVECONFIGURATION, ASN_INTEGER   , RWRITE, var_basicMgt, 1, { 5 } },
#define   MGTHOSTNAME           6
  { MGTHOSTNAME         , ASN_OCTET_STR , RWRITE, var_basicMgt, 1, { 6 } },
#define   MGTDOMAINNAME         7
  { MGTDOMAINNAME       , ASN_OCTET_STR , RWRITE, var_basicMgt, 1, { 7 } },
#define   MGTNODENETADDRESS     8
  { MGTNODENETADDRESS   , ASN_IPADDRESS , RWRITE, var_basicMgt, 1, { 8 } },
#define   MGTNODESUBNETMASK     9
  { MGTNODESUBNETMASK   , ASN_IPADDRESS , RWRITE, var_basicMgt, 1, { 9 } },
#define   MGTDHCPSTATUS         10
  { MGTDHCPSTATUS       , ASN_INTEGER   , RWRITE, var_basicMgt, 1, { 10 } },
#define   MGTDHCPSTARTNETADDR   11
  { MGTDHCPSTARTNETADDR , ASN_IPADDRESS , RWRITE, var_basicMgt, 1, { 11 } },
#define   MGTDHCPNUMBERUSERS    12
  { MGTDHCPNUMBERUSERS  , ASN_INTEGER   , RWRITE, var_basicMgt, 1, { 12 } },
#define   MGTCOMMUNITYINDEX     15
  { MGTCOMMUNITYINDEX   , ASN_INTEGER   , RONLY , var_mgtCommunityTable, 3, { 13,1,1 } },
#define   MGTCOMMUNITYNAME      16
  { MGTCOMMUNITYNAME    , ASN_OCTET_STR , RWRITE, var_mgtCommunityTable, 3, { 13,1,2 } },
#define   MGTCOMMUNITYTYPE      17
  { MGTCOMMUNITYTYPE    , ASN_INTEGER   , RWRITE, var_mgtCommunityTable, 3, { 13,1,3 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_basicMgt():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_basicMgt(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("basicMgt", basicMgt_variables, variable4,
               basicMgt_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_basicMgt():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
int
get_single_ip(char *ipaddr, int which)
{
	int ip[4]={0,0,0,0};
	int ret;

	ret = sscanf(ipaddr,"%d.%d.%d.%d",&ip[0],&ip[1],&ip[2],&ip[3]);

	return ip[which];	
}
unsigned char *
var_basicMgt(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static unsigned long abc, lan_ipaddr;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
        char arg[1000],ip4[1000];
	int ip[3]={0,0,0};


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case MGTSYSTEMRESET:
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ enter mgtsystemreset ++++\r\n");   // amin add 2004/02/03 
#endif	
        *write_method = write_mgtSystemReset;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case MGTFACTORYRESET:
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ enter mgtfactoryreset ++++\r\n");   // amin add 2004/02/03 
#endif	
        *write_method = write_mgtFactoryReset;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case MGTADMINISTRATOR:
        *write_method = write_mgtAdministrator;
        *string = 0;
	sprintf(string, "****");
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ http_passwd = [%s] ++++\r\n ", nvram_safe_get("http_passwd")) ;
	fprintf(stderr,"\r\n++++ http_passwd = [%s] ++++\r\n ", string) ;
#endif	
        *var_len = strlen(string);
        return (unsigned char *) string;

    case MGTADMINUSERNAME:
        *write_method = write_mgtAdminUsername;
        *string = 0;
	sprintf(string, "%s", nvram_safe_get("http_username"));
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ http_username = [%s] ++++\r\n ", nvram_safe_get("http_username")) ;
	fprintf(stderr,"\r\n++++ http_username = [%s] ++++\r\n ", string) ;
#endif	
        *var_len = strlen(string);
        return (unsigned char *) string;

    case MGTSAVECONFIGURATION:
        *write_method = write_mgtSaveConfiguration;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case MGTHOSTNAME:
        *write_method = write_mgtHostName;
        *string = 0;
       	sprintf(string, "%s", nvram_safe_get("wan_hostname"));
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ wan_hostame = [%s] ++++\r\n ", nvram_safe_get("wan_hostname")) ;
	fprintf(stderr,"\r\n++++ wan_hostname = [%s] ++++\r\n ", string) ;
#endif	
	*var_len = strlen(string);
        return (unsigned char *) string;

    case MGTDOMAINNAME:
        *write_method = write_mgtDomainName;
        *string = 0;
        sprintf(string, "%s", nvram_safe_get("wan_domain"));
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ wan_domain = [%s] ++++\r\n ", nvram_safe_get("wan_domain")) ;
	fprintf(stderr,"\r\n++++ wan_domain = [%s] ++++\r\n ", string) ;
#endif	
	*var_len = strlen(string);
        return (unsigned char *) string;

    case MGTNODENETADDRESS:
        *write_method = write_mgtNodeNetAddress;
        *string = 0;
        sprintf(string, "%s", nvram_safe_get("lan_ipaddr"));
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ lan_ipaddr = [%s] ++++\r\n ", nvram_safe_get("lan_ipaddr")) ;
	fprintf(stderr,"\r\n++++ lan_ipaddr = [%s] ++++\r\n ", string) ;
#endif	
//	*var_len = strlen(string);
	*var_len = 4;
        lan_ipaddr = inet_addr(&string);
#ifdef DEBUG_SNMP	    
        fprintf(stderr,"\r\n++++ inet_addr_abc = [%d] ++++\r\n", lan_ipaddr);
#endif	
        return (unsigned char *) &lan_ipaddr;

    case MGTNODESUBNETMASK:
        *write_method = write_mgtNodeSubnetMask;
        *string = 0;
        sprintf(&string, "%s", nvram_safe_get("lan_netmask"));
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ lan_netmask = [%s] ++++\r\n ", nvram_safe_get("lan_netmask")) ;
	fprintf(stderr,"\r\n++++ lan_netmask = [%s] ++++\r\n ", &string) ;
#endif	
//	*var_len = strlen(string);
	*var_len = 4;
        lan_ipaddr = inet_addr(&string);
#ifdef DEBUG_SNMP	    
        fprintf(stderr,"\r\n++++ inet_addr_abc = [%d] ++++\r\n", lan_ipaddr);
#endif	
        return  (struct sockaddr_in *)&lan_ipaddr;

    case MGTDHCPSTATUS:
        *write_method = write_mgtDhcpStatus;
        long_ret = 0;
	if(!strcmp(nvram_safe_get("lan_proto"),"dhcp"))
	{
#ifdef DEBUG_SNMP	    
		fprintf(stderr,"\r\n++++ lan_proto = %s  ++++\r\n", nvram_safe_get("lan_proto"));
#endif	
		long_ret = 1;
	}	
	else
		long_ret = 0;
        return (unsigned char *) &long_ret;

    case MGTDHCPSTARTNETADDR:
        *write_method = write_mgtDhcpStartNetAddr;
        *string = 0;
	memset(&ip4[0], 0, 1000*sizeof(char));

        ip[0]=get_single_ip(nvram_safe_get("lan_ipaddr"),0);
	ip[1]=get_single_ip(nvram_safe_get("lan_ipaddr"),1);
	ip[2]=get_single_ip(nvram_safe_get("lan_ipaddr"),2);
	
	sprintf(&ip4[0], "%d.%d.%d.%s", ip[0],ip[1],ip[2],nvram_safe_get("dhcp_start") );

#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ dhcp_start_ip = [%s] ++++\r\n", ip4);
#endif	
	lan_ipaddr = inet_addr(&ip4);
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++ dhcp_start = [%d] ++++\r\n", lan_ipaddr);
#endif	
        *var_len = 4;
        return (unsigned char *) &lan_ipaddr;

    case MGTDHCPNUMBERUSERS:
        *write_method = write_mgtDhcpNumberUsers;
        long_ret = 0;
	long_ret = atoi(nvram_safe_get("dhcp_num"));
        return (unsigned char *) &long_ret;


    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_mgtCommunityTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_basicMgt above.
 */
unsigned char *
var_mgtCommunityTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
 
#ifdef DEBUG_SNMP	    
  fprintf(stderr,"\r\n++++ mgtcommunitytable = [%d] ++++\r\n",*(name+12) );
#endif  
  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, 2)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case MGTCOMMUNITYINDEX:
//	if( *(name+12) == 1 )    
//        	long_ret = *(name+12);
//	if( *(name+12) == 2 )    
        	long_ret = *(name+12);
#ifdef DEBUG_SNMP	    
	fprintf(stderr,"\r\n++++  mgtcommunityindex [%d] ++++\r\n", long_ret);
#endif	
        return (unsigned char *) &long_ret;

    case MGTCOMMUNITYNAME:
        *write_method = write_mgtCommunityName;
        *string = 0;
	if( *(name+12) == 1 )    
        	sprintf(string,"%s",nvram_safe_get("snmp_getcom"));
	if( *(name+12) == 2 )    
        	sprintf(string,"%s",nvram_safe_get("snmp_setcom"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case MGTCOMMUNITYTYPE:
        *write_method = write_mgtCommunityType;
	if( *(name+12) == 1 )    
        	long_ret = 1;
	if( *(name+12) == 2 )    
        	long_ret = 2;
        return (unsigned char *) &long_ret;


    default:
      ERROR_MSG("");
  }
  return NULL;
}




int
write_mgtSystemReset(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;

#ifdef DEBUG_SNMP	    
  fprintf(stderr,"\r\n++++ enter write_mgtsystemreset ++++\r\n");   // amin add 2004/02/03 
#endif  

  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtSystemReset not ASN_INTEGER ++++\r\n");
#endif  
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtSystemReset: bad length ++++\r\n");
#endif  
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
//	  	kill(1,1);
	  if( *var_val == 1 )
		  system("rc restart");
	  else if( *var_val == 2 )
 		  system("kill 1");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtFactoryReset(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtFactoryReset not ASN_INTEGER ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtFactoryReset: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  	fprintf(stderr,"\r\n++++ restore system default = [%d]++++\r\n", *var_val);
#endif		
		if( *var_val == 1)
		{	
	  		system("nvram set restore_defaults=1");
		  	system("nvram commit");
		  	system("kill 1");
		}	
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtAdministrator(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtAdministrator not ASN_OCTET_STR ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtAdministrator: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting administrator passwd = [%s] ++++\r\n",var_val);
#endif	  
          snprintf(&string, var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ save http_username = [%s] ++++\r\n", &string);	
#endif	  
	  nvram_set("http_passwd", &string);
	  memset(&string, 0, var_val_len+1);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtAdminUsername(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtAdminUsername not ASN_OCTET_STR ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtAdminUsername: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  	fprintf(stderr,"\r\n++++ save http_username = [%s] ++++\r\n", var_val);	
	  	fprintf(stderr,"\r\n++++ save http_username length = [%d] ++++\r\n", var_val_len);	
#endif		
		snprintf(&string, var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP	    
	  	fprintf(stderr,"\r\n++++ save http_username = [%s] ++++\r\n", &string);	
#endif		
		nvram_set("http_username",&string);
		memset(&string, 0, sizeof(string));
//		system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtSaveConfiguration(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtSaveConfiguration not ASN_INTEGER ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtSaveConfiguration: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( *var_val == 1)	
	  	system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtHostName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtHostName not ASN_OCTET_STR ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtHostName: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting wanhostname = [%s] ++++\r\n",var_val);
#endif	  
          snprintf(&string, var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ save wanhostname = [%s] ++++\r\n", &string);	
#endif	  
	  nvram_set("wan_hostname", &string);
	  memset(&string,0,var_val_len+1);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtDomainName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtDomainName not ASN_OCTET_STR ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"\r\n++++ write to mgtDomainName: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting wandomain = [%s] ++++\r\n",var_val);
#endif	  
          snprintf(&string, var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ save wandomain = [%s]++++\r\n", &string);	
#endif	  
	  nvram_set("wan_domain", &string);
	  memset(&string,0,var_val_len+1);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtNodeNetAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtNodeNetAddress not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtNodeNetAddress: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *var_val);
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+1));
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+2));
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+3));
#endif	  
	  sprintf(&string,"%d.%d.%d.%d", *var_val, *(var_val+1), *(var_val+2),*(var_val+3) );
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
#endif	  
	  nvram_set("lan_ipaddr", &string);
	  memset(&string, 0, var_val_len);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtNodeSubnetMask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtNodeSubnetMask not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtNodeSubnetMask: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *var_val);
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+1));
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+2));
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+3));
#endif	  
	  sprintf(&string,"%d.%d.%d.%d", *var_val, *(var_val+1), *(var_val+2),*(var_val+3) );
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
#endif	  
	  nvram_set("lan_netmask", &string);
	  memset(&string, 0, var_val_len);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtDhcpStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtDhcpStatus not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtDhcpStatus: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting lan_proto to [%d] ++++\r\n", *var_val);
#endif	  
	  if( *var_val == 0 )
	  {
#ifdef DEBUG_SNMP	    
	  	fprintf(stderr,"\r\n++++ setting lan_proto to [static] ++++\r\n");
#endif	  
		nvram_set("lan_proto","static");
//	  	system("nvram commit");
//		kill(1,1);
	  }
	  else if(*var_val == 1)
	  {
#ifdef DEBUG_SNMP	    
	  	fprintf(stderr,"\r\n++++ setting lan_proto to [dhcp] ++++\r\n");
#endif	  
		nvram_set("lan_proto","dhcp");
//	        system("nvram commit");
//		kill(1,1);
          }		  
		  
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtDhcpStartNetAddr(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;
            u_char   var_val_buf[4];


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtDhcpStartNetAddr not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtDhcpStartNetAddr: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *var_val);
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+1));
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+2));
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%d] ++++\r\n", *(var_val+3));
#endif	  
	  sprintf(&string,"%d.%d.%d.%d", *var_val, *(var_val+1), *(var_val+2),*(var_val+3) );
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
	  sprintf(&string,"%d", *(var_val+3) );
#endif	  
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
#endif	  
	  nvram_set("dhcp_start", &string);
	  memset(&string, 0, var_val_len);
//	  system("nvram commit");

          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtDhcpNumberUsers(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtDhcpNumberUsers not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtDhcpNumberUsers: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	    
	  fprintf(stderr,"\r\n++++ dhcp user num = [%d] ++++\r\n",*var_val);
#endif	  
	  sprintf(&string,"%d",*var_val);
	  nvram_set("dhcp_num", &string);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtCommunityName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtCommunityName not ASN_OCTET_STR\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtCommunityName: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
  	  
	snprintf(&string,var_val_len+1,"%s",var_val );

#ifdef DEBUG_SNMP	    
  	  fprintf(stderr,"\r\n++++ writemgtcommunityname index = [%d] ++++\r\n",*(name+12) );
  	  fprintf(stderr,"\r\n++++ writemgtcommunityname string = [%s] ++++\r\n",var_val );
  	  fprintf(stderr,"\r\n++++ writemgtcommunityname string = [%s] ++++\r\n",&string );
#endif	  
	  if(*(name+12) == 1)
		  nvram_set("snmp_getcom",&string);
	  if(*(name+12) == 2)
		  nvram_set("snmp_setcom",&string);

//	  system("nvram commit");
//	  kill(1,1);

          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_mgtCommunityType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


#ifdef DEBUG_SNMP	    
  fprintf(stderr,"\r\n++++ write to mgtCommunityType: [%s] ++++\r\n", var_val);
#endif  
  
  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	    
              fprintf(stderr, "write to mgtCommunityType not ASN_INTEGER\n");
#endif  
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	    
              fprintf(stderr,"write to mgtCommunityType: bad length\n");
#endif  
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}






