/* This file was generated by mib2c and is intended for use as a mib module
   for the ucd-snmp snmpd agent. */


#define nvram_safe_get(name) (nvram_get(name)?:"")
#ifdef IN_UCD_SNMP_SOURCE
/* If we're compiling this file inside the ucd-snmp source tree */


/* This should always be included first before anything else */
#include <config.h>


/* minimal include directives */
#include "mibincl.h"
#include "util_funcs.h"


#else /* !IN_UCD_SNMP_SOURCE */


#include <ucd-snmp/ucd-snmp-config.h>
#include <ucd-snmp/ucd-snmp-includes.h>
#include <ucd-snmp/ucd-snmp-agent-includes.h>


#endif /* !IN_UCD_SNMP_SOURCE */

#include <cy_conf.h>
#include <signal.h>
#include <bcmnvram.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "wanMgt.h"

//----------------------------------------------------------------------------

struct dns_lists {
        int num_servers;
        char dns_server[4][16];
};






//---------------------------------------------------------------------------





//#include <utils.h>
//#include <cy_conf.h>
/* 
 * wanMgt_variables_oid:
 *   this is the top level oid that we want to register under.  This
 *   is essentially a prefix, with the suffix appearing in the
 *   variable below.
 */


oid wanMgt_variables_oid[] = { 1,3,6,1,4,1,3955,2,3 };


/* 
 * variable4 wanMgt_variables:
 *   this variable defines function callbacks and type return information 
 *   for the wanMgt mib section 
 */


struct variable4 wanMgt_variables[] = {
/*  magic number        , variable type , ro/rw , callback fn  , L, oidsuffix */
#define   WANINDEX              3
  { WANINDEX            , ASN_INTEGER   , RONLY , var_wanConnectionTable, 3, { 1,1,1 } },
#define   WANIFINDEX            4
  { WANIFINDEX          , ASN_INTEGER   , RONLY , var_wanConnectionTable, 3, { 1,1,2 } },
#define   WANCONNECTIONTYPE     5
  { WANCONNECTIONTYPE   , ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,3 } },
#define   WANNETADDRESS         6
  { WANNETADDRESS       , ASN_IPADDRESS , RWRITE, var_wanConnectionTable, 3, { 1,1,4 } },
#define   WANPHYSICALADDR       7
  { WANPHYSICALADDR     , ASN_OCTET_STR , RWRITE, var_wanConnectionTable, 3, { 1,1,5 } },
#define   WANSUBNETMASK         8
  { WANSUBNETMASK       , ASN_IPADDRESS , RWRITE, var_wanConnectionTable, 3, { 1,1,6 } },
#define   WANDEFAULTGATEWAY     9
  { WANDEFAULTGATEWAY   , ASN_IPADDRESS , RWRITE, var_wanConnectionTable, 3, { 1,1,7 } },
#define   WANDHCPSTATUS         10
  { WANDHCPSTATUS       , ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,8 } },
#define   WANLOGINSTATUS        11
  { WANLOGINSTATUS      , ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,9 } },
#define   WANLOGINUSERNAME      12
  { WANLOGINUSERNAME    , ASN_OCTET_STR , RWRITE, var_wanConnectionTable, 3, { 1,1,10 } },
#define   WANLOGINPASSWORD      13
  { WANLOGINPASSWORD    , ASN_OCTET_STR , RWRITE, var_wanConnectionTable, 3, { 1,1,11 } },
#define   WANWORKINGMODE        14
  { WANWORKINGMODE      , ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,13 } },
#define   WANCONNECTEDSTATE     15
  { WANCONNECTEDSTATE   , ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,14 } },
#define   WANCONNECTEDIDLETIME  16
  { WANCONNECTEDIDLETIME, ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,15 } },
#define   WANCONNECTEDREDIALPERIOD  17
  { WANCONNECTEDREDIALPERIOD, ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,16 } },
//#define   WANDNSAUTONEGOSTATUS  18
//  { WANDNSAUTONEGOSTATUS, ASN_INTEGER   , RWRITE, var_wanConnectionTable, 3, { 1,1,17 } },
#define   WANDNSNETADDRESSINDEX  20
  { WANDNSNETADDRESSINDEX, ASN_INTEGER   , RONLY , var_wanDnsNetAddressTable, 3, { 2,1,1 } },
#define   WANDNSIFINDEX         21
  { WANDNSIFINDEX       , ASN_INTEGER   , RONLY , var_wanDnsNetAddressTable, 3, { 2,1,2 } },
#define   WANDNSNETADDRESS      22
  { WANDNSNETADDRESS    , ASN_IPADDRESS , RWRITE, var_wanDnsNetAddressTable, 3, { 2,1,3 } },

};
/*    (L = length of the oidsuffix) */


/*
 * init_wanMgt():
 *   Initialization routine.  This is called when the agent starts up.
 *   At a minimum, registration of your variables should take place here.
 */
void init_wanMgt(void) {


  /* register ourselves with the agent to handle our mib tree */
  REGISTER_MIB("wanMgt", wanMgt_variables, variable4,
               wanMgt_variables_oid);


  /* place any other initialization junk you need here */
}


/*
 * var_wanMgt():
 *   This function is called every time the agent gets a request for
 *   a scalar variable that might be found within your mib section
 *   registered above.  It is up to you to do the right thing and
 *   return the correct value.
 *     You should also correct the value of "var_len" if necessary.
 *
 *   Please see the documentation for more information about writing
 *   module extensions, and check out the examples in the examples
 *   and mibII directories.
 */
unsigned char *
var_wanMgt(struct variable *vp, 
                oid     *name, 
                size_t  *length, 
                int     exact, 
                size_t  *var_len, 
                WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;


  if (header_generic(vp,name,length,exact,var_len,write_method)
                                  == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {



    default:
      ERROR_MSG("");
  }
  return NULL;
}


/*
 * var_wanConnectionTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wanMgt above.
 */
unsigned char *
var_wanConnectionTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret;
  static u_long ulong_ret, wan_ipaddr;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
  int i=0,j=0;
  static unsigned char s_wan_mac[20];
  static unsigned char i_wan_mac[6];

  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
  if (header_simple_table(vp,name,length,exact,var_len,write_method, 1)
                                                == MATCH_FAILED )
    return NULL;


  /* 
   * this is where we do the value assignments for the mib results.
   */
  switch(vp->magic) {


    case WANINDEX:
        
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WANIFINDEX:
        
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WANCONNECTIONTYPE:
        *write_method = write_wanConnectionType;
        long_ret = 0;
	if( !strcmp(nvram_safe_get("wan_proto"),"dhcp"))
        	long_ret = 1;
	else if( !strcmp(nvram_safe_get("wan_proto"),"static"))
       		long_ret = 2;
	else if( !strcmp(nvram_safe_get("wan_proto"),"pppoe"))
       		long_ret = 3;
	else if( !strcmp(nvram_safe_get("wan_proto"),"pptp"))
        	long_ret = 5;
	else if( !strcmp(nvram_safe_get("wan_proto"),"heartbeat"))
       		long_ret = 6;
        return (unsigned char *) &long_ret;

    case WANNETADDRESS:
        *write_method = write_wanNetAddress;
        *string = 0;
//        *var_len = strlen(string);
        *var_len = 4;
	sprintf(&string, "%s", nvram_safe_get("wan_ipaddr"));
        wan_ipaddr = inet_addr(&string);
        return (unsigned char *) &wan_ipaddr;

    case WANPHYSICALADDR:
        *write_method = write_wanPhysicalAddr;
        *string = 0;
//        *var_len = strlen(string);
	sprintf(&s_wan_mac, "%s", nvram_safe_get("wan_hwaddr"));
	j=1;
	for(i=0;i<18;i++)
	{
		if(i==0)
		{
			i_wan_mac[0]=strtol(&s_wan_mac[0],NULL,16);
//			fprintf(stderr,"H2D=[%d]",i_wan_mac[0]);
		}
		else if(s_wan_mac[i]==':')
		{
			i_wan_mac[j]=strtol(&s_wan_mac[i+1],NULL,16);
//			fprintf(stderr,"H2D=[%d]",i_wan_mac[j]);
			j++;
		}
	}
        *var_len = 6;
//        return (unsigned char *) string;
        return (unsigned char *) i_wan_mac;

    case WANSUBNETMASK:
        *write_method = write_wanSubnetMask;
        *string = 0;
//        *var_len = strlen(string);
        *var_len = 4;
	sprintf(&string, "%s", nvram_safe_get("wan_netmask"));
        wan_ipaddr = inet_addr(&string);
        return (unsigned char *) &wan_ipaddr;

    case WANDEFAULTGATEWAY:
        *write_method = write_wanDefaultGateway;
        *string = 0;
//        *var_len = strlen(string);
        *var_len = 4;
	sprintf(&string, "%s", nvram_safe_get("wan_gateway"));
        wan_ipaddr = inet_addr(&string);
        return (unsigned char *) &wan_ipaddr;

    case WANDHCPSTATUS:
        *write_method = write_wanDHCPStatus;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WANLOGINSTATUS:
        *write_method = write_wanLoginStatus;
        long_ret = 0;
        return (unsigned char *) &long_ret;

    case WANLOGINUSERNAME:
        *write_method = write_wanLoginUserName;
        *string = 0;
	sprintf(&string, "%s", nvram_safe_get("pppoe_username"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WANLOGINPASSWORD:
        *write_method = write_wanLoginPassword;
        *string = 0;
	sprintf(&string, "%s", nvram_safe_get("pppoe_passwd"));
        *var_len = strlen(string);
        return (unsigned char *) string;

    case WANWORKINGMODE:
        *write_method = write_wanWorkingMode;
        long_ret = 0;
	if( !strcmp(nvram_safe_get("wk_mode"),"gateway"))
        	long_ret = 1;
	if( !strcmp(nvram_safe_get("wk_mode"),"router"))
        	long_ret = 2;
        return (unsigned char *) &long_ret;

    case WANCONNECTEDSTATE:
        *write_method = write_wanConnectedState;
        long_ret = 0;
	if( !strcmp(nvram_safe_get("ppp_demand"),"0"))
        	long_ret = 0;
	if( !strcmp(nvram_safe_get("ppp_demand"),"1"))
        	long_ret = 1;
        return (unsigned char *) &long_ret;

    case WANCONNECTEDIDLETIME:
        *write_method = write_wanConnectedIdleTime;
        long_ret = atoi(nvram_safe_get("pppoe_idletime"));
        return (unsigned char *) &long_ret;

    case WANCONNECTEDREDIALPERIOD:
        *write_method = write_wanConnectedRedialPeriod;
        long_ret = 0;
        long_ret = atoi(nvram_safe_get("ppp_redialperiod"));
        return (unsigned char *) &long_ret;

//    case WANDNSAUTONEGOSTATUS:
//       *write_method = write_wanDnsAutonegoStatus;
//        long_ret = 0;
//        long_ret = atoi(nvram_safe_get("ppp_redialperiod"));
//        return (unsigned char *) &long_ret;

    default:
      ERROR_MSG("");
  }
  return NULL;
}

//------------------------------------------------------------
/*
char nameserver[4][16];

int
read_resolv_conf(void)
{
	FILE *fp;
	char ch, string[20];
	int count = 0;
	struct nameserv {
				int num;
				char ipaddr[4][16];
	}xyz;			
	memset(&string,0,sizeof(string));
	memset(&nameserver,0,sizeof(nameserver));
	fp = fopen("/tmp/resolv.conf","r");
	if( fp <= 0 )
		goto end;
	fprintf(stderr,"\r\n +++ open resolv.conf fp = [%d] +++ \r\n",fp);
	while(!feof(fp))
	{
		printf("[%c]",ch = getc(fp));
		if( (ch >= '0' && ch <= '9') || ch == '.' || ch == '\n'){
				sprintf(&string,"%c",ch);
				strcat(&nameserver[count],&string);
				fprintf(stderr,"\r\n%d=[%s]",count,&nameserver[count]);

				if(ch == '\n')
				{	
					count++;
					memset(&string,0,20*sizeof(char));
				}	
		}
	}	
	fprintf(stderr,"\r\n1=[%s]",&nameserver[0]);
	fprintf(stderr,"\r\n2=[%s]",&nameserver[1]);
	fprintf(stderr,"\r\n3=[%s]",&nameserver[2]);
        char arg[1000];
	int x;
	for(x=0;x<1000;x++)
	{
		if( (arg[x]=='(') && (arg[x+1]=='$') )
			break;
		putc(arg[x], fp);
	}	
	fclose(fp);
end:	
	printf("\r\n++++ end read_resolv_conf() ++++\r\n");
}	
*/
//------------------------------------------------------------------------------------

/*
 * var_wanDnsNetAddressTable():
 *   Handle this table separately from the scalar value case.
 *   The workings of this are basically the same as for var_wanMgt above.
 */
unsigned char *
var_wanDnsNetAddressTable(struct variable *vp,
    	    oid     *name,
    	    size_t  *length,
    	    int     exact,
    	    size_t  *var_len,
    	    WriteMethod **write_method)
{


  /* variables we may use later */
  static long long_ret, dns_ipaddr;
  static u_long ulong_ret;
  static unsigned char string[SPRINT_MAX_LEN];
  static oid objid[MAX_OID_LEN];
  static struct counter64 c64;
//  char *nameserver;

  /* 
   * This assumes that the table is a 'simple' table.
   *	See the implementation documentation for the meaning of this.
   *	You will need to provide the correct value for the TABLE_SIZE parameter
   *
   * If this table does not meet the requirements for a simple table,
   *	you will need to provide the replacement code yourself.
   *	Mib2c is not smart enough to write this for you.
   *    Again, see the implementation documentation for what is required.
   */
//  if (header_simple_table(vp,name,length,exact,var_len,write_method, TABLE_SIZE)
  if (header_simple_table(vp,name,length,exact,var_len,write_method, 3)
                                                == MATCH_FAILED )
    return NULL;
//  read_resolv_conf();
//  fprintf(stderr,"\r\n1[%s]",nameserver[0]);
//  fprintf(stderr,"\r\n2[%s]",nameserver[1]);
//  fprintf(stderr,"\r\n3[%s]",nameserver[2]);
//get_dns_list();
//nvram_safe_get("lan_ipaddr");
//  fprintf(stderr,"\r\n +++ wandnsnetaddressindex = [%d] +++\r\n",*(name+11));
  /* 
   * this is where we do the value assignments for the mib results.
   */
//----------------------------------------------------------------------------------------
 
  static unsigned char string1[SPRINT_MAX_LEN];
  static unsigned char string2[SPRINT_MAX_LEN];
  int wan_get_flag = 0;
          memset(&string1[0],0,SPRINT_MAX_LEN);
          memset(&string2[0],0,SPRINT_MAX_LEN);
	  sprintf(&string1,"%s",nvram_safe_get("wan_dns"));
	  sprintf(&string2,"%s",nvram_safe_get("wan_get_dns"));
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ nvram get wan_dns data = [%s]++++\r\n", &string1);
#endif	  
	  int count=0,space=1;
	  char *ptr0,*ptr1,*ptr2;
	  ptr0 = &string1[0];
	  ptr1 = NULL;
	  ptr2 = NULL;
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ write wan dns ptr0 data = [%s]++++\r\n", ptr0);
#endif	  
	  while( string1[count] != '\0')
	  {
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"%c", string1[count]);
#endif	  
		  if( string1[count] == ' ' )
		  {	  
			  string1[count]='\0';
			  if( space <= 2 && space == 1)
				ptr1 = &string1[count+1];	  
			  if( space <= 2 && space == 2)
				ptr2 = &string1[count+1];	  
			  space++;
				  
		  }		  
		  count++;
	  }	  
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"string length = [%d]\r\n",count);
	  fprintf(stderr,"string 1 = [%s]\r\n",ptr0);
	  fprintf(stderr,"string 2 = [%s]\r\n",ptr1);
	  fprintf(stderr,"string 3 = [%s]\r\n",ptr2);
#endif	  
//------------------------------------------------------------------------------------  
  switch(vp->magic) {


    case WANDNSNETADDRESSINDEX:
        
        long_ret = 0;
#ifdef DEBUG_SNMP	  
  	fprintf(stderr,"\r\n++++ wandnsnetaddressindex = [%d] ++++\r\n",*(name+12));
#endif	  
	long_ret = *(name+12);
        return (unsigned char *) &long_ret;

    case WANDNSIFINDEX:
        
        long_ret = 0;
#ifdef DEBUG_SNMP	  
  	fprintf(stderr,"\r\n++++ wandnsifindex = [%d] ++++\r\n",*(name+12));
#endif	  
	long_ret = *(name+12);
        return (unsigned char *) &long_ret;

    case WANDNSNETADDRESS:
	if( *ptr0 < '1' || *ptr0 > '9')
		wan_get_flag = 1;
	else if( !ptr1 || *ptr1 < '1' || *ptr1 > '9')
		wan_get_flag = 2;
	else if( !ptr2 || *ptr2 < '1' || *ptr2 > '9')
		wan_get_flag = 3;
	
        *write_method = write_wanDnsNetAddress;
#ifdef DEBUG_SNMP	  
  	fprintf(stderr,"\r\n++++ wandnsnetaddress = [%d] ++++\r\n",*(name+12));
  	fprintf(stderr,"\r\n++++ wan_get_flag = [%d] ++++\r\n",wan_get_flag );
#endif	  
	if( *(name+12)==1 )
	{
		if( ptr0 && *ptr0 != ' ' && *ptr0 != '\n' && (*ptr0 >= '1' && *ptr0 <= '9') )	
			sprintf(&string,"%s",ptr0);
		else if( string2[0] != ' ' && wan_get_flag == 1 )
		{	
			sprintf(&string,"%s",&string2);
		}	
	}	
	if( *(name+12)==2 )
	{	
		if( ptr1 && *ptr1 != ' ')	
			sprintf(&string,"%s",ptr1);
		else if( string2[0] != ' ' && wan_get_flag == 2 )
		{	
			sprintf(&string,"%s",&string2);
		}	
	}	
	if( *(name+12)==3 )
	{	
		if( ptr2 && *ptr2 != ' ')	
			sprintf(&string,"%s",ptr2);
		else if( string2[0] != ' ' && wan_get_flag == 3 )
		{	
			sprintf(&string,"%s",&string2);
		}	
	}	
	wan_get_flag = 0 ;	
#ifdef DEBUG_SNMP	  
  	fprintf(stderr,"\r\n++++ string = [%s] ++++\r\n",&string);
#endif	  
        dns_ipaddr = inet_addr(&string);
        memset(&string[0],0,SPRINT_MAX_LEN);
#ifdef DEBUG_SNMP	  
  	fprintf(stderr,"\r\n++++ dns_ipaddr = [%d] ++++\r\n",dns_ipaddr);
#endif	  
	if( dns_ipaddr < 0 )
	{	
		dns_ipaddr = NULL;
#ifdef DEBUG_SNMP	  
		fprintf(stderr,"\r\n++++ assign zero to return ++++\r\n");
#endif	  
	}	
#ifdef DEBUG_SNMP	  
 	fprintf(stderr,"\r\n++++ dns_ipaddr = [%d] ++++\r\n",dns_ipaddr);
#endif	  
        *var_len = 4;
        return (unsigned char *) &dns_ipaddr;


    default:
      ERROR_MSG("");
  }
  return NULL;
}




int
write_wanConnectionType(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanConnectionType not ASN_INTEGER\n");
#endif	  
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanConnectionType: bad length\n");
#endif	  
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ change wan_proto to [%d] ++++\r\n",*var_val);
#endif	  
	  if( *var_val == 1)
		  nvram_set("wan_proto","dhcp");
	  else if( *var_val == 2)
		  nvram_set("wan_proto","static");
	  else if( *var_val == 3)
		  nvram_set("wan_proto","pppoe");
	  else if( *var_val == 5)
		  nvram_set("wan_proto","pptp");
	  else if( *var_val == 6)
		  nvram_set("wan_proto","heartbeat");
	  
//	  system("nvram commit");
//	  system("kill 1");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanNetAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanNetAddress not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanNetAddress: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( !strcmp(nvram_safe_get("wan_proto"), "static") || !strcmp(nvram_safe_get("wan_proto"), "pptp") )
	  {	  
	          sprintf(&string,"%d.%d.%d.%d", *var_val, *(var_val+1), *(var_val+2),*(var_val+3) );
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"\r\n++++ setting dhcp start ip addr [%s] ++++\r\n", &string);
#endif		  
		  nvram_set("wan_ipaddr", &string);
		  memset(&string, 0, var_val_len);
//		  system("nvram commit");
//                  system("kill 1");
	  }
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanPhysicalAddr(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanPhysicalAddr not ASN_OCTET_STR\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanPhysicalAddr: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanSubnetMask(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanSubnetMask not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanSubnetMask: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  sprintf(&string,"%d.%d.%d.%d", *var_val, *(var_val+1), *(var_val+2),*(var_val+3) );
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ setting wan netmask [%s] ++++\r\n", &string);
#endif	  
	  nvram_set("wan_netmask", &string);
	  memset(&string, 0, var_val_len);
//	  system("nvram commit");
//          system("kill 1");


	  break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanDefaultGateway(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanDefaultGateway not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanDefaultGateway: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  sprintf(&string,"%d.%d.%d.%d", *var_val, *(var_val+1), *(var_val+2),*(var_val+3) );
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ setting wan gateway [%s] ++++\r\n", &string);
#endif	  
	  nvram_set("wan_gateway", &string);
	  memset(&string, 0, var_val_len);
//	  system("nvram commit");
//          system("kill 1");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanDHCPStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanDHCPStatus not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanDHCPStatus: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ change dhcp status ++++\r\n");
	  fprintf(stderr,"\r\n++++ var_val = [%d] ++++\r\n", *var_val);
#endif	  
	  if( !strcmp( nvram_safe_get("wan_proto"),"dhcp" ) )
	  {	  
		  if( *var_val == 0 )
		  {
#ifdef DEBUG_SNMP	  
		  	fprintf(stderr,"\r\n++++ change dhcp status release ++++\r\n");
#endif	  
			system("nvram set action_service=dhcp_release");
			system("nvram commit");
			system("kill -SIGUSR1 1");
		  }	  
		  if( *var_val == 1 )
		  {
#ifdef DEBUG_SNMP	  
		  	fprintf(stderr,"\r\n++++ change dhcp status renew ++++\r\n");
#endif	  
			system("nvram commit");
			system("killall -SIGUSR1 udhcpc");
		  }	  
	  }
	  else
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"\r\n++++ wan_proto != dhcp ++++\r\n");
#endif	  
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanLoginStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanLoginStatus not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanLoginStatus: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */

#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ change wanlogin status ++++\r\n");
	  fprintf(stderr,"\r\n++++ var_val = [%d] ++++\r\n", *var_val);
#endif	  
	  if( !strcmp( nvram_safe_get("wan_proto"),"pppoe" ) )
	  {	  
		  if( *var_val == 0 )
		  {
#ifdef DEBUG_SNMP	  
		  	fprintf(stderr,"\r\n++++ change wanlogin status disconnect ++++\r\n");
#endif	  
			system("nvram set action_service=stop_pppoe");
			system("nvram commit");
			system("kill -SIGUSR1 1");
		  }	  
		  if( *var_val == 1 )
		  {
#ifdef DEBUG_SNMP	  
		  	fprintf(stderr,"\r\n++++ change wanlogin status connect ++++\r\n");
#endif	  
			system("nvram set action_service=start_pppoe");
			system("nvram commit");
			system("kill -SIGUSR1 1");
		  }	  
	  }
	  else
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"\r\n++++ wan_proto != pppoe ++++\r\n");
#endif	  


	  break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanLoginUserName(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"\r\n++++ write to wanLoginUserName not ASN_OCTET_STR ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"\r\n++++ write to wanLoginUserName: bad length ++++\r\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          
          snprintf(&string, var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ save pppoe_username = [%s] ++++\r\n", &string);	
#endif	      
	  nvram_set("pppoe_username", &string);
	  memset(&string, 0, var_val_len+1);
//	  system("nvram commit");
	  break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanLoginPassword(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_OCTET_STR){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanLoginPassword not ASN_OCTET_STR\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanLoginPassword: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          snprintf(&string, var_val_len+1,"%s", var_val);
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ save pppoe_passwd = [%s] ++++\r\n", &string);	
#endif	  
	  nvram_set("pppoe_passwd", &string);
	  memset(&string, 0, var_val_len+1);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanWorkingMode(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanWorkingMode not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanWorkingMode: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( *var_val == 1){		  		
		  nvram_set("wk_mode","gateway");
//		  system("nvram commit");
//		  system("kill 1");
	  }	  
	  if( *var_val == 2)
		  nvram_set("wk_mode","router");
//		  system("nvram commit");
//		  system("kill 1");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanConnectedState(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanConnectedState not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanConnectedState: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
	  if( *var_val == 0){		  		
		  nvram_set("ppp_demand","0");
//		  system("nvram commit");
//		  system("kill 1");
	  }	  
	  if( *var_val == 1){
		  nvram_set("ppp_demand","1");
//		  system("nvram commit");
//		  system("kill 1");
	  }	  
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanConnectedIdleTime(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;
  static unsigned char string[SPRINT_MAX_LEN];


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanConnectedIdleTime not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanConnectedIdleTime: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ wanConnectedIdleTime ++++\r\n");
	  fprintf(stderr,"\r\n++++ wanConnectedIdleTime = [%d] ++++\r\n",*var_val);
#endif	  
	  sprintf(&string,"%d",*var_val);
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ wanConnectedIdleTime = [%s] ++++\r\n",&string);
#endif	  
	  nvram_set("pppoe_idletime",&string);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}




int
write_wanConnectedRedialPeriod(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;
  static unsigned char string[SPRINT_MAX_LEN];


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanConnectedRedialPeriod not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanConnectedRedialPeriod: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++  wanConnectedRedialPeriod ++++\r\n");
	  fprintf(stderr,"\r\n++++  wanConnectedRedialPeriod = [%d] ++++\r\n",*var_val);
#endif	      
	  sprintf(&string,"%d",*var_val);
	  nvram_set("ppp_redialperiod",&string);
//	  system("nvram commit");
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}

int
write_wanDnsAutonegoStatus(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static long *long_ret;
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_INTEGER){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanConnectedRedialPeriod not ASN_INTEGER\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(long_ret)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanConnectedRedialPeriod: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
          long_ret = (long *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in long_ret for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}


int
write_wanDnsNetAddress(int      action,
            u_char   *var_val,
            u_char   var_val_type,
            size_t   var_val_len,
            u_char   *statP,
            oid      *name,
            size_t   name_len)
{
  static unsigned char string[SPRINT_MAX_LEN];
  static unsigned char string2[SPRINT_MAX_LEN];
  static unsigned char string3[SPRINT_MAX_LEN];
  int size;


  switch ( action ) {
        case RESERVE1:
          if (var_val_type != ASN_IPADDRESS){
#ifdef DEBUG_SNMP	  
              fprintf(stderr, "write to wanDnsNetAddress not ASN_IPADDRESS\n");
#endif	      
              return SNMP_ERR_WRONGTYPE;
          }
          if (var_val_len > sizeof(string)){
#ifdef DEBUG_SNMP	  
              fprintf(stderr,"write to wanDnsNetAddress: bad length\n");
#endif	      
              return SNMP_ERR_WRONGLENGTH;
          }
          break;


        case RESERVE2:
          size = var_val_len;
//          string = (char *) var_val;


          break;


        case FREE:
             /* Release any resources that have been allocated */
          break;


        case ACTION:
             /* The variable has been stored in string for
             you to use, and you have just been asked to do something with
             it.  Note that anything done here must be reversable in the UNDO case */
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ write wan dns ++++\r\n");
	  fprintf(stderr,"\r\n++++ write wan dns index = [%d]++++\r\n", *(name+12));
	  fprintf(stderr,"\r\n++++ write wan dns var_val = [%d.%d.%d.%d]++++\r\n", *var_val,*( var_val+1), *(var_val+2), *(var_val+3) );
#endif	  
	  sprintf(&string2,"%d.%d.%d.%d", *var_val,*( var_val+1), *(var_val+2), *(var_val+3) );
          memset(&string[0],0,SPRINT_MAX_LEN);
	  sprintf(&string,"%s",nvram_safe_get("wan_dns"));
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ write wan dns data = [%s]++++\r\n", &string);
#endif	  
	  int count=0,space=1;
	  char ns1[4][16],*ptr0,*ptr1,*ptr2;
	  memset(&ns1,0,sizeof(ns1));
	  ptr0 = &string[0];
	  ptr1 = NULL;
	  ptr2 = NULL;
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"\r\n++++ write wan dns data = [%s]++++\r\n", ptr0);
#endif	  
	  while( string[count] != '\0')
	  {
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"%c", string[count]);
#endif	  
		  if( string[count] == ' ' )
		  {	  
			  string[count]='\0';
			  if( space <= 2 && space == 1)
				ptr1 = &string[count+1];	  
			  if( space <= 2 && space == 2)
				ptr2 = &string[count+1];	  
			  space++;
				  
		  }		  
		  count++;
	  }	  
#ifdef DEBUG_SNMP	  
	  fprintf(stderr,"string length = [%d]\r\n",count);
	  fprintf(stderr,"string 1 = [%s]\r\n",ptr0);
	  fprintf(stderr,"string 2 = [%s]\r\n",ptr1);
	  fprintf(stderr,"string 3 = [%s]\r\n",ptr2);
#endif	  
	  if( *(name+12) == 1 )
	  {

  		  memset(&string3[0],0,SPRINT_MAX_LEN);
//		  sprintf(&string3,"%s %s %s",&string2,ptr1,ptr2);
		  if( strcmp(&string2," ") || strcmp(&string2,NULL) )
		  {
			  strcat(&string3,&string2);
			  strcat(&string3," ");
		  }	 
		  if( ptr1 && *ptr1 != ' ' )
		  {
			  strcat(&string3,ptr1);
			  strcat(&string3," ");
		  }	 
		  if( ptr2 && *ptr2 != ' ' )
		  {
			  strcat(&string3,ptr2);
//			  strcat(&string3," ");
		  }	 

#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"[%s]\r\n",&string3);
#endif	  
		  nvram_set("wan_dns",&string3);
	  }	  
	  if( *(name+12) == 2 )
	  {
  		  memset(&string3[0],0,SPRINT_MAX_LEN);
//		  sprintf(&string3,"%s %s %s",ptr0,&string2,ptr2);
		  if( ptr0 && *ptr0 != ' ' )
		  {
			  strcat(&string3,ptr0);
			  strcat(&string3," ");
		  }	 
		  if( strcmp(&string2," ") || strcmp(&string2,NULL) )
		  {
			  strcat(&string3,&string2);
			  strcat(&string3," ");
		  }	 
		  if( ptr2 && *ptr2 != ' ' )
		  {
			  strcat(&string3,ptr2);
//			  strcat(&string3," ");
		  }	 
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"[%s]\r\n",&string3);
#endif	  
		  nvram_set("wan_dns",&string3);
	  }	  
	  if( *(name+12) == 3 )
	  {
  		  memset(&string3[0],0,SPRINT_MAX_LEN);
//		  sprintf(&string3,"%s %s %s",ptr0,ptr1,&string2);
		  if( ptr0 && *ptr0 != ' ' )
		  {
			  strcat(&string3,ptr0);
			  strcat(&string3," ");
		  }	 
		  if( ptr1 && *ptr1 != ' ' )
		  {
			  strcat(&string3,ptr1);
			  strcat(&string3," ");
		  }	 
		  if( strcmp(&string2," ") || strcmp(&string2,NULL) )
		  {
			  strcat(&string3,&string2);
//			  strcat(&string3," ");
		  }	 
#ifdef DEBUG_SNMP	  
		  fprintf(stderr,"[%s]\r\n",&string3);
#endif	  
		  nvram_set("wan_dns",&string3);
	  }	  

	  

          break;


        case UNDO:
             /* Back out any changes made in the ACTION case */
          break;


        case COMMIT:
             /* Things are working well, so it's now safe to make the change
             permanently.  Make sure that anything done here can't fail! */
          break;
  }
  return SNMP_ERR_NOERROR;
}






